//Carlos Gershenson
//carlos@jlagunez.iquimica.unam.mx

import java.awt.*;
import java.io.*; 
import java.util.*;
import vrml.external.field.*;
import vrml.external.Node;
import vrml.external.Browser;
import vrml.external.exception.*;
import ArqColsCond;
import netscape.security.PrivilegeManager;

public class Animat extends Frame implements Serializable {
  String id;//animat's name
  int type=0;//0=prey;1=predator
  ArqColsCond a;
  Browser browser;
  Random rnd = new Random();
  Vector vp = new Vector ((int)20,(int)3);//vector for perception
  Vector trailvec = new Vector ((int)80,(int)10);
  float rp = 20;//radius of perception
  boolean explo,avd;
  float strength = 1, lucidity = 1, safety = 1, hunger = 0, thirst = 0, fatigue = 0;
  float avoidalfa = 0,avoidbeta = 0;
  long syncstep = 0;
  Node ani,ani2;
  float[] pos = new float[3]; //animat position
  float[] rot = new float[4];       //animat orientation 
  EventInSFVec3f posEv; 
  EventInSFRotation rotEv; 
  EventInSFRotation rotEv2;
  boolean trailf = false;
  boolean verbose = false;
  boolean immortality = false;
  boolean showblack = false,showcoup = false,died=false;
  Node materialC;
  EventInSFColor diffuseColorC;
  Node materialS;
  EventInSFColor diffuseColorS;
  Node materialT;
  EventInSFColor diffuseColorT;
  Node trails;
  Node[] trail;
  EventInMFNode addTrailCh;
  EventInMFNode rmTrailCh;
  String trailstr = new String();
  float[] color = new float[3];
  float[] color2 = new float[3];
  float[] pos2 = new float[3];
  float[] rot2 = new float[4];
  float[] rot3 = new float[4];
  double aleph = 0.1;
  TextArea output = null;
  Choice greekCh;
  TextField rpf,anx,anz,anth,greekf;
  Panel scrolls;
  Scrollbar hungerbar,thirstbar,safetybar,fatiguebar,strengthbar,luciditybar;
  public Image logo=null;

  public Animat(String name, long t) {
    super ("Animat "+name);
    try {
      PrivilegeManager.enablePrivilege("UniversalFileRead");
      logo = Toolkit.getDefaultToolkit().getImage("Asiaicon.gif");
      setIconImage(logo);
    } catch (netscape.security.ForbiddenTargetException e) {
      e.printStackTrace(System.err);
    }
    id=name;
    a = new ArqColsCond();
    setFont(new Font("TimesRoman",Font.PLAIN,12));
    setBackground(Color.white);
    setLayout(new FlowLayout());
    add(new Button("Verbose"));
    add(new Button("Trail"));
    add(new Button("Rm Trail"));
    add(new Button("Clear Output")); 
    add(new Button("Immortality"));
    add(new Button("Blackboards"));
    add(new Button("Couplings"));
    output = new TextArea(9, 80);
    output.setEditable(false);
    output.setFont(new Font("TimesRoman",Font.PLAIN,12));
    add(output);
    output.appendText("Animat " + name + " created at t = "+String.valueOf(t)+"\n");
    add( new Label("Animat   X:"));
    anx = new TextField("0.0",4);
    add(anx);
    add( new Label("Z:"));
    anz = new TextField("0.0",4);
    add(anz);
    add( new Label("th:"));
    anth = new TextField("0.0",4);
    add(anth);
    add(new Button("Set Pos&Rot"));
    add( new Label("Rp:"));
    rpf = new TextField("20.0",4);
    add(rpf);
    add(new Button("Set Rp"));
    greekCh = new Choice();
    greekCh.addItem("alfa");
    greekCh.addItem("beta");
    greekCh.addItem("gamma");
    greekCh.addItem("phi");
    greekCh.addItem("kappa");
    greekCh.addItem("lambda");
    greekCh.addItem("mu");
    greekCh.addItem("aleph");
    add(greekCh);
    greekf = new TextField(String.valueOf(a.alfa),3);
    add(greekf);
    add(new Button("Set"));
    add( new Label("        "));
    scrolls = new Panel();
    scrolls.setFont(new Font("TimesRoman",Font.PLAIN,10));
    scrolls.setLayout(new GridLayout(0,2, 5, 3));
    scrolls.add(new Label("Strength"));
    strengthbar = new Scrollbar(Scrollbar.HORIZONTAL,100,0,0,101);
    strengthbar.setBackground(Color.pink);
    scrolls.add(strengthbar);
    scrolls.add(new Label("Lucidity          "));
    luciditybar = new Scrollbar(Scrollbar.HORIZONTAL,100,0,0,101);
    luciditybar.setBackground(Color.yellow);
    scrolls.add(luciditybar);
    scrolls.add(new Label("Safety"));
    safetybar = new Scrollbar(Scrollbar.HORIZONTAL,100,0,0,101);
    safetybar.setBackground(Color.white);
    scrolls.add(safetybar);
    scrolls.add(new Label("Fatigue"));
    fatiguebar = new Scrollbar(Scrollbar.HORIZONTAL,0,0,0,101);
    fatiguebar.setBackground(Color.red);
    scrolls.add(fatiguebar);
    scrolls.add(new Label("Thirst"));
    thirstbar = new Scrollbar(Scrollbar.HORIZONTAL,0,0,0,101);
    thirstbar.setBackground(Color.blue);
    scrolls.add(thirstbar);
    scrolls.add(new Label("Hunger"));
    hungerbar = new Scrollbar(Scrollbar.HORIZONTAL,0,0,0,101);
    hungerbar.setBackground(Color.green);
    scrolls.add(hungerbar);
    scrolls.add(new Label(""));
    scrolls.add(new Button("Set Int St"));
    add(scrolls);
    resize(540,480);
    show();
    rot3[0] = rot[0] = (float)0.0;
    rot3[1] = rot[1] = (float)1.0;
    rot3[2] = rot[2] = (float)0.0;
    rot3[3] = rot[3] = (float)0.0;	 
    pos[0] = (float)0.0;
    pos[1] = (float)0.0;
    pos[2] = (float)0.0;
    color[0] = 0;
    color[1] = 0;
    color[2] = 0;
    
  }

  public void ini() {
    browser = (Browser) SimFrame.browser;
  }  

  void addtrail() {
    trailstr = "Shape{\n"+
    "geometry IndexedLineSet{\n"+
    "        coord Coordinate {\n"+
    "            point [ "+String.valueOf(pos2[0])+" "+String.valueOf(pos2[1])+" "+String.valueOf(pos2[2])+"\n"+
    "                        "+String.valueOf(pos[0])+" "+String.valueOf(pos[1])+" "+String.valueOf(pos[2])+"]\n"+ 
    "        }\n"+
    "        coordIndex[0 1 -1]\n"+
    "        color Color{\n"+
    "            color [ "+String.valueOf(color2[0])+" "+String.valueOf(color2[1])+" "+String.valueOf(color2[2])+"\n"+
    "                        "+String.valueOf(color[0])+" "+String.valueOf(color[1])+" "+String.valueOf(color[2])+"]\n"+ 
    "        }\n"+
    "        colorIndex[0 1 -1]        \n"+
    "    }\n"+
    "}\n";
    trail = browser.createVrmlFromString(trailstr);
    trailvec.addElement(trail);
    addTrailCh.setValue(trail); 
  }
  
  public boolean action(Event evt, Object whichAction) {
    int opt=-1;
    boolean ok = true; 
    if (evt.target instanceof Button) {
      Button b = (Button) evt.target;
      if (b.getLabel() == "Set") {
        float greekprov =-1;
        try {
          greekprov = Float.valueOf(greekf.getText()).floatValue();
        }
        catch (NumberFormatException e) {
          output.appendText("Please fill the fileds correctly!\n");
          ok = false;
        }
        if (ok) {
          if ((greekprov < 0)||(greekprov > 1)) {
            output.appendText("Greek values must be between 0 and 1!\n");
          } else {
            opt = greekCh.getSelectedIndex();
            switch(opt) {
              case (0):a.setalfa(greekprov);
              output.appendText("New alfa (motivation/preactivation factor): "+String.valueOf(a.alfa)+"\n");
              break;
              case (1):a.beta = greekprov;
              output.appendText("New beta (learning factor): "+String.valueOf(a.beta)+"\n");
              break;
              case (2):a.gamma = greekprov;
              output.appendText("New gamma (reactivity factor): "+String.valueOf(a.gamma)+"\n");
              break;
              case (3):a.phi = greekprov;
              output.appendText("New phi (reactivity factor): "+String.valueOf(a.phi)+"\n");
              break;
              case (4):a.kappa = greekprov;
              output.appendText("New kappa (perceptual persistance factor): "+String.valueOf(a.kappa)+"\n");
              break;
              case (5):a.lambda = greekprov;
              output.appendText("New lambda (learning factor): "+String.valueOf(a.lambda)+"\n");
              break;
              case (6):a.mu = greekprov;
              output.appendText("New mu (unlearning factor): "+String.valueOf(a.mu)+"\n");
              break;
              case (7):aleph = greekprov;
              output.appendText("New aleph (forget rate): "+String.valueOf(aleph)+"\n");
              break;
              default:
              output.appendText("Error. Please select a valid letter\n");
              break;
            }
          }
        }
      }
      else if (b.getLabel() == "Verbose") {
        if(verbose)
          output.appendText("OK, I'll be quiet.\n");
        else
          output.appendText("To inform and serve, sir!\n");
        verbose =! verbose;
      }
      else if (b.getLabel() == "Blackboards") {
        if(showblack)
          output.appendText("OK, no more blackboards.\n");
        else
          output.appendText("All blackboard levels will be displayed\n");
        showblack =! showblack;
      }
      else if (b.getLabel() == "Couplings") {
        if(showcoup)
          output.appendText("OK, no more learning coupling strengths.\n");
        else
          output.appendText("Coupling strengths involved in learning processes will be displayed.\n");
        showcoup =! showcoup;
      }
      else if (b.getLabel() == "Immortality") {
        if(immortality)
          output.appendText("What the heck, back from Elysium...\n");
        else
          output.appendText("Animat immortal (but not vampire! (Animat needs no blood)).\n");
        immortality =! immortality;
      }
      else if (b.getLabel() == "Rm Trail") {
        int i;
        output.appendText("Deleting trail... please be patient\n");
        for (i = 0;i < trailvec.size();i++) {
          rmTrailCh.setValue((Node[])trailvec.elementAt(i));
        }
        trailvec.removeAllElements();
        output.appendText("Trail deleted.\n");
      }
      else if (b.getLabel() == "Set Pos&Rot") {
        float xprov = 0,zprov = 0,thprov = 0;
        try {
          xprov = Float.valueOf(anx.getText()).floatValue();
          zprov = Float.valueOf(anz.getText()).floatValue();
          thprov = Float.valueOf(anth.getText()).floatValue();
        }
        catch (NumberFormatException e) {
          output.appendText("Please fill the fileds correctly!\n");
          ok = false;
        }
        if (ok) {
          pos[0] = xprov;
          pos[2] = zprov;
          rot[3] = thprov;
          output.appendText("New animat position: "+String.valueOf(xprov)+", "+String.valueOf(zprov)+", new orientation: "+String.valueOf(thprov)+"\n");
          posEv.setValue(pos);
          rotEv.setValue(rot);
        }
      }
      else if (b.getLabel() == "Set Int St") {
        strength = (float)((float)strengthbar.getValue()/100);
        lucidity = (float)((float)luciditybar.getValue()/100);
        safety = (float)((float)safetybar.getValue()/100);
        fatigue = (float)((float)fatiguebar.getValue()/100);
        thirst = (float)((float)thirstbar.getValue()/100);
        hunger = (float)((float)hungerbar.getValue()/100);
        output.appendText("Internal states set: "+String.valueOf(strength)+", "+String.valueOf(lucidity)+", "
        +String.valueOf(safety)+", "+String.valueOf(fatigue)+", "+String.valueOf(thirst)+", "+String.valueOf(hunger)+", "+"\n");
      }
      else if (b.getLabel() == "Set Rp") {
        float rpprov =-1;
        try {
          rpprov = Float.valueOf(rpf.getText()).floatValue();
        }
        catch (NumberFormatException e) {
          output.appendText("Please fill the fileds correctly!\n");
          ok = false;
        }
        if (ok) {
          if (rpprov <= 0) {
            output.appendText("Radius must be positive!\n");
          } else {
            rp = rpprov;
            output.appendText("New radius of perception: "+String.valueOf(rp)+"\n");
          }
        }
      }
      else if (b.getLabel() == "Clear Output") {
        output.setText("\nNice and clean...\n");
      }
      else if (b.getLabel() == "Trail") {
        if(trailf)
          output.appendText("Don't leave trail.\n");
        else
          output.appendText("Leave trail.\n");
        trailf =! trailf;
      }
    }
    else if (evt.target instanceof Choice) {
      Choice whichChoice = (Choice) evt.target;
      if (whichChoice == greekCh) {
        opt = greekCh.getSelectedIndex();
        switch(opt) {
          case (0):greekf.setText(String.valueOf(a.alfa));
          break;
          case (1):greekf.setText(String.valueOf(a.beta));
          break;
          case (2):greekf.setText(String.valueOf(a.gamma));
          break;
          case (3):greekf.setText(String.valueOf(a.phi));
          break;
          case (4):greekf.setText(String.valueOf(a.kappa));
          break;
          case (5):greekf.setText(String.valueOf(a.lambda));
          break;
          case (6):greekf.setText(String.valueOf(a.mu));
          break;
          case (7):greekf.setText(String.valueOf(aleph));
          break;
        }
      } 
    }
    return true;
  }
  
  public void turnAlfa(double th) {
    float h = pos[2]- (float) Math.cos(rot[3]);
    float k = pos[0]- (float) Math.sin(rot[3]);
    pos[2] = (float) h+(float) Math.cos(rot[3]+th);
    pos[0] = (float) k+(float) Math.sin(rot[3]+th);
    rot[3] += th; 	
  }
  public void turnBeta(double th) {
    float h = pos[2]- (float) Math.cos(rot[3]+1.58);
    float k = pos[0]- (float) Math.sin(rot[3]+1.58);
    pos[2] = (float) h+(float) Math.cos(rot[3]+1.58-th);
    pos[0] = (float) k+(float) Math.sin(rot[3]+1.58-th);
    rot[3] -= th; 	
  }
  
  public void forget() {
    int i;
    ExtStim es,es2;
    for (i = 0;i < vp.size();i++) {
      es = (ExtStim)vp.elementAt(i);
      es2 = new ExtStim(es);
      es2.s-= aleph;
      if (es2.id == 4)es2.id = 1;
      if (es2.id == 5)es2.id = 2;
      if (es2.id == 12)es2.id = 11;
      vp.setElementAt(es2,i);
    }
    for (i = 0;i < vp.size();i++) {
      es = (ExtStim)vp.elementAt(i);
      if((es.id == 3)||(es.id == 6)||(es.s <= 0)) {
        vp.removeElementAt(i);
      }
    }
  }
  
  public void reforget(ExtStim es) {
    int i;
    ExtStim es2;
    for (i = 0;i < vp.size();i++) {
      es2 = (ExtStim)vp.elementAt(i);
      if((es.x == es2.x)&&(es.z == es2.z)&&(es.id == es2.id)) {
        vp.removeElementAt(i);
        } else
        if((es.x == es2.x)&&(es.z == es2.z)&&(((es.id == 1)||(es.id == 4))&&((es2.id == 1)||(es2.id == 4)))) {
        vp.removeElementAt(i);
        } else
        if((es.x == es2.x)&&(es.z == es2.z)&&(((es.id == 2)||(es.id == 5))&&((es2.id == 2)||(es2.id == 5)))) {
        vp.removeElementAt(i);
        } else
        if((es.x == es2.x)&&(es.z == es2.z)&&(((es.id == 11)||(es.id == 12))&&((es2.id == 11)||(es2.id == 12)))) {
        vp.removeElementAt(i);
        } else
        if((es.x == es2.x)&&(es.z == es2.z)&&(((es.id == 3)||(es.id == 6))&&((es2.id == 3)||(es2.id == 6)))) {
        vp.removeElementAt(i);
      }
    }
  }
  
  public void percep() {
    Vector toberemoved = new Vector ((int)10,(int)3);
    Vector fw = new Vector ((int)10,(int)3);
    ExtStim es,es2,es3;
    int i,i2;
    boolean tevi,rmst,wallnear2;
    boolean really;
    int obstcnt = 0;
    float wnrange = (float) 1.5;
    float z1,z2,x1,x2,j,k;
    float z = pos[2],x = pos[0], th = rot[3];
    forget();
    avoidalfa = (float)0.78*strength;
    avoidbeta = (float)0.78*strength;
    th = (float)(((th+(3*Math.PI))%(2*Math.PI))-Math.PI);
    for(i = 0;i < SimFrame.env.watervp.size();i++) {
      es = (ExtStim) SimFrame.env.watervp.elementAt(i);
      if(((Math.pow((es.z-pos[2]),2.0)+Math.pow((es.x-pos[0]),2.0)) <= Math.pow((rp*lucidity),2.0))&&
        (((0 < (rot[3]%(2*Math.PI)))&&(rot[3] <= Math.PI))?(es.x > (pos[0]+(Math.tan(rot[3]+(Math.PI/2))*(es.z-pos[2])))):
        (es.x < (pos[0]+(Math.tan(rot[3]+(Math.PI/2))*(es.z-pos[2])))))) {
        es.id = (int)2;
        if((Math.pow((es.z-pos[2]),2.0)+Math.pow((es.x-pos[0]),2.0)) <= Math.pow(2.5,2.0)) {
          es.id = (int)5;
        }
        reforget(es);
        vp.addElement(es);
      }
    }
    for(i = 0;i < SimFrame.env.foodvp.size();i++) {
      es = (ExtStim) SimFrame.env.foodvp.elementAt(i);
      if(((Math.pow((es.z-pos[2]),2.0)+Math.pow((es.x-pos[0]),2.0)) <= Math.pow((rp*lucidity),2.0))&&
        (((0 < rot[3])&&(rot[3] <= Math.PI))?(es.x > (pos[0]+(Math.tan(rot[3]+(Math.PI/2))*(es.z-pos[2])))):
        (es.x < (pos[0]+(Math.tan(rot[3]+(Math.PI/2))*(es.z-pos[2])))))) {
        es.id = (int)1;
        if((Math.pow((es.z-pos[2]),2.0)+Math.pow((es.x-pos[0]),2.0)) <= Math.pow(2.5,2.0)) {
          es.id = (int)4;
        }
        reforget(es);
        vp.addElement(es);
      }
    }
    for(i = 0;i < SimFrame.env.grassvp.size();i++) {
      es = (ExtStim) SimFrame.env.grassvp.elementAt(i);
      if(((Math.pow((es.z-pos[2]),2.0)+Math.pow((es.x-pos[0]),2.0)) <= Math.pow((rp*lucidity),2.0))&&
        (((0 < rot[3])&&(rot[3] <= Math.PI))?(es.x > (pos[0]+(Math.tan(rot[3]+(Math.PI/2))*(es.z-pos[2])))):
        (es.x < (pos[0]+(Math.tan(rot[3]+(Math.PI/2))*(es.z-pos[2])))))) {
        es.id = (int)11;
        if((Math.pow((es.z-pos[2]),2.0)+Math.pow((es.x-pos[0]),2.0)) <= Math.pow(2.5,2.0)) {
          es.id = (int)12;
        }
        reforget(es);
        vp.addElement(es);
      }
    }
    for(i = 0;i < SimFrame.env.blobvp.size();i++) {
      es = (ExtStim) SimFrame.env.blobvp.elementAt(i);
      if(((Math.pow((es.z-pos[2]),2.0)+Math.pow((es.x-pos[0]),2.0)) <= Math.pow((rp*lucidity),2.0))&&
        (((0 < rot[3])&&(rot[3] <= Math.PI))?(es.x > (pos[0]+(Math.tan(rot[3]+(Math.PI/2))*(es.z-pos[2])))):
        (es.x < (pos[0]+(Math.tan(rot[3]+(Math.PI/2))*(es.z-pos[2])))))) {
        es.id = (int)8;
        reforget(es);
        vp.addElement(es);
      }
    }
    for(i = 0;i < SimFrame.env.rspotvp.size();i++) {
      es = (ExtStim) SimFrame.env.rspotvp.elementAt(i);
      if(((Math.pow((es.z-pos[2]),2.0)+Math.pow((es.x-pos[0]),2.0)) <= Math.pow((rp*lucidity),2.0))&&
        (((0 < rot[3])&&(rot[3] <= Math.PI))?(es.x > (pos[0]+(Math.tan(rot[3]+(Math.PI/2))*(es.z-pos[2])))):
        (es.x < (pos[0]+(Math.tan(rot[3]+(Math.PI/2))*(es.z-pos[2])))))) {
        es.id = (int)9;
        reforget(es);
        vp.addElement(es);
      }
    }
    for(i = 0;i < SimFrame.env.yspotvp.size();i++) {
      es = (ExtStim) SimFrame.env.yspotvp.elementAt(i);
      if(((Math.pow((es.z-pos[2]),2.0)+Math.pow((es.x-pos[0]),2.0)) <= Math.pow((rp*lucidity),2.0))&&
        (((0 < rot[3])&&(rot[3] <= Math.PI))?(es.x > (pos[0]+(Math.tan(rot[3]+(Math.PI/2))*(es.z-pos[2])))):
        (es.x < (pos[0]+(Math.tan(rot[3]+(Math.PI/2))*(es.z-pos[2])))))) {
        es.id = (int)10;
        reforget(es);
        vp.addElement(es);
      }
    }
    for(i = 0;i < SimFrame.env.wallvp.size();i++) {
      es = (ExtStim) SimFrame.env.wallvp.elementAt(i);
      z1 = (float)es.z-(es.s2/2);
      z2 = (float)es.z+(es.s2/2);
      x1 = (float)es.x-(es.s/2);
      x2 = (float)es.x+(es.s/2);
      tevi = false;
      wallnear2 = false;
      really = false;
      for(j = z1;j < z2;j+= 0.5) { 
        k = x1;
        if(((Math.pow((j-pos[2]),2.0)+Math.pow((k-pos[0]),2.0)) <= Math.pow((rp*lucidity),2.0))&&
          (((0 < rot[3])&&(rot[3] <= Math.PI))?(k > (pos[0]+(Math.tan(rot[3]+(Math.PI/2))*(j-pos[2])))):
          (k < (pos[0]+(Math.tan(rot[3]+(Math.PI/2))*(j-pos[2])))))) {
          es.id = (int)3;
          tevi = true;
          if((Math.pow((j-pos[2]),2.0)+Math.pow((k-pos[0]),2.0)) <= Math.pow(wnrange,2.0)) {
            wallnear2 = true;
          }
        }
        k = x2;
        if(((Math.pow((j-pos[2]),2.0)+Math.pow((k-pos[0]),2.0)) <= Math.pow((rp*lucidity),2.0))&&
          (((0 < rot[3])&&(rot[3] <= Math.PI))?(k > (pos[0]+(Math.tan(rot[3]+(Math.PI/2))*(j-pos[2])))):
          (k < (pos[0]+(Math.tan(rot[3]+(Math.PI/2))*(j-pos[2])))))) {
          es.id = (int)3;
          tevi = true;
          if((Math.pow((j-pos[2]),2.0)+Math.pow((k-pos[0]),2.0)) <= Math.pow(wnrange,2.0)) {
            wallnear2 = true;
          }
        }
      }
      for(k = x1;k < x2;k+= 0.5) { 
        j = z1;
        if(((Math.pow((j-pos[2]),2.0)+Math.pow((k-pos[0]),2.0)) <= Math.pow((rp*lucidity),2.0))&&
          (((0 < rot[3])&&(rot[3] <= Math.PI))?(k > (pos[0]+(Math.tan(rot[3]+(Math.PI/2))*(j-pos[2])))):
          (k < (pos[0]+(Math.tan(rot[3]+(Math.PI/2))*(j-pos[2])))))) {
          es.id = (int)3;
          tevi = true;
          if((Math.pow((j-pos[2]),2.0)+Math.pow((k-pos[0]),2.0)) <= Math.pow(wnrange,2.0)) {
            wallnear2 = true;
          }
        }
        j = z2;
        if(((Math.pow((j-pos[2]),2.0)+Math.pow((k-pos[0]),2.0)) <= Math.pow((rp*lucidity),2.0))&&
          (((0 < rot[3])&&(rot[3] <= Math.PI))?(k > (pos[0]+(Math.tan(rot[3]+(Math.PI/2))*(j-pos[2])))):
          (k < (pos[0]+(Math.tan(rot[3]+(Math.PI/2))*(j-pos[2])))))) {
          es.id = (int)3;
          tevi = true;
          if((Math.pow((j-pos[2]),2.0)+Math.pow((k-pos[0]),2.0)) <= Math.pow(wnrange,2.0)) {
            wallnear2 = true;
          }
        }
      }
      if (tevi) {
        //remove stimuli behind wall
        for(i2 = 0;i2 < vp.size();i2++) {
          es2 = (ExtStim)vp.elementAt(i2);//ext stim to be removed
          if ((es2.id == 1)||(es2.id == 2)||(es2.id == 8)||(es2.id == 9)||(es2.id == 10)) {
            rmst = false;
            if((z <= z1)&&(x <= x1)/*&&(0<=th)&&(th<=(Math.PI/2))*/
              &&(z1 < es2.z)&&(x1 < es2.x)&&(es2.x < ((((x2-x)/(z1-z))*(es2.z-z))+x))&&(es2.x > ((((x1-x)/(z2-z))*(es2.z-z))+x))) {
              //output.appendText("    I'm in rule 1");
              rmst = true; }
            if((z1 < z)&&(z < z2)&&(x <= x1)/*&&((Math.PI/4)<=th)&&(th<=(3*Math.PI/4))*/
              &&(x1 < es2.x)&&(es2.x > ((((x1-x)/(z2-z))*(es2.z-z))+x))&&(es2.x > ((((x1-x)/(z1-z))*(es2.z-z))+x))) {
              //output.appendText("    I'm in rule 2");
              rmst = true; }
            if((z2 <= z)&&(x <= x1)/*&&((Math.PI/2)<=th)&&(th<=(Math.PI))*/
              &&(z2 > es2.z)&&(x1 < es2.x)&&(es2.x < ((((x2-x)/(z2-z))*(es2.z-z))+x))&&(es2.x > ((((x1-x)/(z1-z))*(es2.z-z))+x))) {
              //output.appendText("    I'm in rule 3");
              rmst = true; }
            if((z2 <= z)&&(x1 < x)&&(x < x2)/*&&((3*Math.PI/4)<=th)&&(th<=(-3*Math.PI/4))*/
              &&(z2 > es2.z)&&(es2.x > ((((x1-x)/(z2-z))*(es2.z-z))+x))&&(es2.x < ((((x2-x)/(z2-z))*(es2.z-z))+x))) {
              //output.appendText("    I'm in rule 4");
              rmst = true; }
            if((z2 <= z)&&(x2 <= x)/*&&((-Math.PI)<=th)&&(th<=(-Math.PI/2))*/
              &&(z2 > es2.z)&&(x2 > es2.x)&&(es2.x < ((((x2-x)/(z1-z))*(es2.z-z))+x))&&(es2.x > ((((x1-x)/(z2-z))*(es2.z-z))+x))) {
              //output.appendText("    I'm in rule 5");
              rmst = true; }
            if((z1 < z)&&(z < z2)&&(x2 <= x)/*&&((-3*Math.PI/4)<=th)&&(th<=(-Math.PI/4))*/
              &&(x2 > es2.x)&&(es2.x < ((((x2-x)/(z1-z))*(es2.z-z))+x))&&(es2.x < ((((x2-x)/(z2-z))*(es2.z-z))+x))) {
              //output.appendText("    I'm in rule 6");
              rmst = true; }
            if((z <= z1)&&(x2 <= x)/*&&((-Math.PI/2)<=th)&&(th<=0)*/
              &&(z1 < es2.z)&&(x2 > es2.x)&&(es2.x < ((((x2-x)/(z2-z))*(es2.z-z))+x))&&(es2.x > ((((x1-x)/(z1-z))*(es2.z-z))+x))) {
              //output.appendText("    I'm in rule 7");
              rmst = true; }
            if((z <= z1)&&(x1 < x)&&(x < x2)/*&&((-Math.PI/4)<=th)&&(th<=(Math.PI/4))*/
              &&(z1 < es2.z)&&(es2.x > ((((x1-x)/(z1-z))*(es2.z-z))+x))&&(es2.x < ((((x2-x)/(z1-z))*(es2.z-z))+x))) {
              //output.appendText("    I'm in rule 8");
              rmst = true; }
            if(rmst) {
              toberemoved.addElement(es2);
              //output.appendText("ExtStim removed at: "+String.valueOf(es2.x)+", "+String.valueOf(es2.z)+"; size: "+String.valueOf(es2.s) +"; id: "+String.valueOf(es2.id)+"\n");
            }
          }
        }
        if(wallnear2) {
          es.id = (int)6;
          if(z < z1) {
            if(((-5*Math.PI/8) < th)&&(th <= 0)) {
              avoidalfa = 0;
              avoidbeta = (float)((2*((Math.PI/2)+th))+(strength*0.39)+(rnd.nextFloat()*0.3));
              really = true;obstcnt++;
            } 
            if((0 < th)&&(th < (5*Math.PI/8))) {
              avoidalfa = (float)((2*((Math.PI/2)-th))-(strength*0.39)+(rnd.nextFloat()*0.3));
              avoidbeta = 0;
              really = true;obstcnt++;
            }
            //output.appendText("  rule 1, th:"+String.valueOf(th)+" alfa: "+String.valueOf(avoidalfa)+" beta: "+String.valueOf(avoidbeta)+" t: "+String.valueOf(t)+"\n");
          }
          if(z > z2) {
            if(((3*Math.PI/8) < th)&&(th <= (Math.PI))) {
              avoidalfa = 0;
              avoidbeta = (float)((2*(th-(Math.PI/2)))+(strength*0.39)+(rnd.nextFloat()*0.3));
              really = true;obstcnt++;
            } 
            if(((-Math.PI) <= th)&&(th < (-3*Math.PI/8))) {
              avoidalfa = (float)((-2*((Math.PI/2)+th))-(strength*0.39)+(rnd.nextFloat()*0.3));
              avoidbeta = 0;
              really = true;obstcnt++;
            }
            //output.appendText("  rule 2, th:"+String.valueOf(th)+" alfa: "+String.valueOf(avoidalfa)+" beta: "+String.valueOf(avoidbeta)+" t: "+String.valueOf(t)+"\n");
          }
          if(x < x1) {
            if(((-Math.PI/8) < th)&&(th <= (Math.PI/2))) {
              avoidalfa = 0;
              avoidbeta = (float)(2*(th)+(strength*0.39)+(rnd.nextFloat()*0.3));
              really = true;obstcnt++;
            } 
            if((((Math.PI/2) < th)&&(th < (Math.PI)))||(th < (-7*Math.PI/8))) {
              if(th < (-7*Math.PI/8))
                avoidalfa = (float)((2*((Math.PI)-th))-(strength*0.39)+(rnd.nextFloat()*0.3));
              avoidbeta = 0;
              if(th < (-7*Math.PI/8))
                avoidalfa = (float)((2*((Math.PI)-(th+(2*Math.PI))))-(strength*0.39)+(rnd.nextFloat()*0.3));
              really = true;obstcnt++;
            }
            //output.appendText("  rule 3, th:"+String.valueOf(th)+" alfa: "+String.valueOf(avoidalfa)+" beta: "+String.valueOf(avoidbeta)+" t: "+String.valueOf(t)+"\n");
          }
          if(x2 < x) {
            if((((-Math.PI) < th)&&(th <= (-Math.PI/2)))||(th > (7*Math.PI/8))) {
              avoidalfa = 0;
              avoidbeta = (float)((2*((Math.PI)+th))+(strength*0.39)+(rnd.nextFloat()*0.3));
              if(th > (7*Math.PI/8))
                avoidbeta = (float)((2*((Math.PI)+(th-(2*Math.PI))))+(strength*0.39)+(rnd.nextFloat()*0.3));
              really = true;obstcnt++;
            } 
            if(((-Math.PI/2) < th)&&(th < (Math.PI/8))) {
              avoidalfa = (float)((-2*(-th))-(strength*0.39)+(rnd.nextFloat()*0.3));
              avoidbeta = 0;
              really = true;obstcnt++;
            }
            //output.appendText("  rule 4, th:"+String.valueOf(th)+" alfa: "+String.valueOf(avoidalfa)+" beta: "+String.valueOf(avoidbeta)+" t: "+String.valueOf(t)+"\n");
          }
        }
        if( ! really) {
          //output.appendText("  the obstacle was behind animat. t="+String.valueOf(t)+"\n");
          es.id = (int)3;
        } 
        reforget(es);
        vp.addElement(es);
        if(verbose) {
          output.appendText("Wall percieved from: "+String.valueOf(x1)+", "+String.valueOf(z1)+" to "+String.valueOf(x2)+", "+String.valueOf(z2)+"\n");
        }
      }
    }
    if(obstcnt > 1) {
      avoidalfa = avoidbeta = (float)1.56*strength;
      //output.appendText("    there was more than one obstacle\n");
    }
    for(i = 0;i < toberemoved.size();i++) {
      vp.removeElement(toberemoved.elementAt(i)); 
    }
    for(i = 0;i < vp.size();i++) {
      es = (ExtStim) vp.elementAt(i);
      if((es.id == 1)||(es.id == 4)) {
        for(i2 = 0;i2 < vp.size();i2++) {
          es2 = (ExtStim) vp.elementAt(i2);
          if((es2.id == 2)||(es2.id == 5)) {
            if((Math.abs(es.x-es2.x) < 3)&&(Math.abs(es.z-es2.z) < 3)) {
              es3 = new ExtStim((es.x+es2.x)/2,(es.z+es2.z)/2,(es.s+es2.s)/2,0,(int)7);
              fw.addElement(es3);
            }
          }
        }
        if(verbose) {
          if(es.id == 1)output.appendText("Food percieved at: "+String.valueOf(es.x)+", "+String.valueOf(es.z)+"; size: "+String.valueOf(es.s)+"\n");
          if(es.id == 4)output.appendText("Food at range: "+String.valueOf(es.x)+", "+String.valueOf(es.z)+"; size: "+String.valueOf(es.s)+"\n");
        }
      }
      if((es.id == 2)||(es.id == 5)) {
        if(verbose) {
          if(es.id == 2)output.appendText("Water percieved at: "+String.valueOf(es.x)+", "+String.valueOf(es.z)+"; size: "+String.valueOf(es.s)+"\n");
          if(es.id == 5)output.appendText("Water at range: "+String.valueOf(es.x)+", "+String.valueOf(es.z)+"; size: "+String.valueOf(es.s)+"\n");
        }
      }
      if((es.id == 8)&&(verbose)) output.appendText("Blob percieved at: "+String.valueOf(es.x)+", "+String.valueOf(es.z)+"; size: "+String.valueOf(es.s)+"\n");
      if((es.id == 9)&&(verbose)) output.appendText("Red spot percieved at: "+String.valueOf(es.x)+", "+String.valueOf(es.z)+"; size: "+String.valueOf(es.s)+"\n");
      if((es.id == 10)&&(verbose)) output.appendText("Yellow spot percieved at: "+String.valueOf(es.x)+", "+String.valueOf(es.z)+"; size: "+String.valueOf(es.s)+"\n");
      if((es.id == 11)&&(verbose)) output.appendText("Grass percieved at: "+String.valueOf(es.x)+", "+String.valueOf(es.z)+"; size: "+String.valueOf(es.s)+"\n");
      if((es.id == 12)&&(verbose)) output.appendText("Grass at range: "+String.valueOf(es.x)+", "+String.valueOf(es.z)+"; size: "+String.valueOf(es.s)+"\n");
    }
    for(i = 0;i < fw.size();i++) {
      es = (ExtStim) fw.elementAt(i);
      if(verbose) {
        output.appendText("Food and water percieved at: "+String.valueOf(es.x)+", "+String.valueOf(es.z)+"; size: "+String.valueOf(es.s)+"\n");
      }
      reforget(es);
      vp.addElement(es);
    }
  }
  
  ExtStim getmaxpond(int id) {
    int i,pos2 = 0;
    float pond,max =-1;
    ExtStim es;
    for (i = 0;i < vp.size();i++) {
      es = (ExtStim)vp.elementAt(i);
      if(es.id == id) {
        pond = (float)((es.s/(2*Math.sqrt(Math.pow(es.z-pos[2],2)+Math.pow(es.x-pos[0],2)))));
        if (pond > max) {
          max = pond;
          pos2 = i;
        }
      }
    }
    if (max > 0)
      return (ExtStim) vp.elementAt(pos2);
    else
      switch (a.getmaxNS()) {
      case (12): return getmaxpond(9);//rspot
      case (13): return getmaxpond(10);//yspot
      default: return new ExtStim();
    }
  } 
  
  float getmaxpondval(int id) {
    int i;
    float pond,max = 0;
    ExtStim es;
    for (i = 0;i < vp.size();i++) {
      es = (ExtStim)vp.elementAt(i);
      if(es.id == id) {
        if ((id == 3)||(id == 6)) {
          pond = (float)((es.s*es.s2)/(Math.sqrt((Math.pow((es.z-pos[2]),2)+Math.pow((es.x-pos[0]),2)))));
          max+= pond;
        }
        else {
          pond = (float)((es.s/(2*Math.sqrt(Math.pow(es.z-pos[2],2)+Math.pow(es.x-pos[0],2)))));
          max+= pond;
        }
      }
    }
    if (max > 0)
      return max+(float)0.5;
    else
      return max;
  } 
  
  void approach(float x, float z) {
    float th = (float) Math.atan2((x-pos[0]),(z-pos[2]));
    if ((syncstep%2) == 0) {
      turnAlfa((th-rot[3])-(strength*0.39));
    } else {
      turnBeta((th-rot[3])+(strength*0.39));
    } 
  }
  
  void runaway(float x, float z) {
    float th = (float) (Math.atan2((x-pos[0]),(z-pos[2])) + Math.PI);
    if ((syncstep%2) == 0) {
      turnAlfa((th-rot[3])-(strength*0.39));
    } else {
      turnBeta((th-rot[3])+(strength*0.39));
    } 
  }
  
  void wander() {
    rot2[0] = 0; rot2[1] = 0; rot2[2] = 0; rot2[3] = (float)0;
    rotEv2.setValue(rot2);
    if (verbose) {
      output.appendText("Wandering...\n");
    }
    if ((syncstep%2) == 0) {
      turnAlfa(rnd.nextFloat()*strength);
    } else {
      turnBeta(rnd.nextFloat()*strength);
    } 
  }
  
  void avoid() {
    rot2[0] = 0; rot2[1] = 0; rot2[2] = 0; rot2[3] = (float)0;
    rotEv2.setValue(rot2);
    if (verbose) {
      output.appendText("Avoiding obstacle...\n");
    }
    if ((syncstep%2) == 0) {
      turnAlfa(avoidalfa);
    } else {
      turnBeta(avoidbeta);
    } 
  }
  
  void explore() {
    rot2[0] = 1; rot2[1] = 0; rot2[2] = 0; rot2[3] = (float)0.1;
    rotEv2.setValue(rot2);
    if (verbose) {
      output.appendText("Exploring...\n");
    }
    if ((syncstep%2) == 0) {
      turnAlfa(0.78*strength);
    } else {
      turnBeta(0.78*strength);
    } 
  }
  
  void rest() {
    rot2[0] = 1; rot2[1] = 0; rot2[2] = 0; rot2[3] = (float)1.2;
    rotEv2.setValue(rot2);
    if (verbose) {
      output.appendText("Resting...\n");
    }
    ExtStim es=getmaxpond(12);
    fatigue-= 0.011*es.s; 
  }
  
  void drink() {
    int i;
    rot2[0] = 1; rot2[1] = 0; rot2[2] = 0; rot2[3] = (float)0.5;
    rotEv2.setValue(rot2);
    ExtStim es2,es3,es = getmaxpond((int)5);
    if (verbose) {
      output.appendText("Drinking...\n");
    }
    if (es.s > 0.2) {
      es3=new ExtStim(es);
      es3.s-= (float)0.2;
      SimFrame.addwater((float)es3.x,(float)es3.z,(float)(es3.s));
      SimFrame.env.watervp.addElement(es3);
    }
    for(i = 0;i < SimFrame.env.watervp.size();i++) {
      es2 = (ExtStim)SimFrame.env.watervp.elementAt(i);
      if (es.equals(es2))
        SimFrame.rmwater(i);
    }
    thirst-= (float)(0.1);
  }
  
  void feed() {
    int i;
    rot2[0] = 1; rot2[1] = 0; rot2[2] = 0; rot2[3] = (float)0.3;
    rotEv2.setValue(rot2);
    ExtStim es2,es3,es = getmaxpond((int)4);
    if (verbose) {
      output.appendText("Feeding...\n");
    }
    if (es.s > 0.2){
      es3=new ExtStim(es);
      es3.s-= (float)0.2;
      SimFrame.addfood((float)es3.x,(float)es3.z,(float)(es3.s));
      SimFrame.env.foodvp.addElement(es3);
    }
    for(i = 0;i < SimFrame.env.foodvp.size();i++) {
      es2 = (ExtStim)SimFrame.env.foodvp.elementAt(i);
      if (es.equals(es2))
        SimFrame.rmfood(i);
    }
    hunger-= (float)(0.1);
  }
  
  void approachfw() {
    rot2[0] = 1; rot2[1] = 0; rot2[2] = 0; rot2[3] = (float)-0.25;
    rotEv2.setValue(rot2);
    ExtStim es = getmaxpond((int)7);
    if (verbose) {
      output.appendText("Approaching food and water at "+String.valueOf(es.x)+", "+String.valueOf(es.z)+"...\n");
    }
    approach(es.x,es.z); 
  }
  
  void approachgrass() {
    rot2[0] = 1; rot2[1] = 0; rot2[2] = 0; rot2[3] = (float)0.4;
    rotEv2.setValue(rot2);
    ExtStim es = getmaxpond((int)11);
    if (verbose) {
      output.appendText("Approaching grass at "+String.valueOf(es.x)+", "+String.valueOf(es.z)+"...\n");
    }
    approach(es.x,es.z); 
  }
  void approachwater() {
    rot2[0] = 1; rot2[1] = 0; rot2[2] = 0; rot2[3] = (float)-0.3;
    rotEv2.setValue(rot2);
    ExtStim es = getmaxpond((int)2);
    if (verbose) {
      output.appendText("Approaching water at "+String.valueOf(es.x)+", "+String.valueOf(es.z)+"...\n");
    }
    approach(es.x,es.z); 
  }
  
  void approachfood() {
    rot2[0] = 1; rot2[1] = 0; rot2[2] = 0; rot2[3] = (float)-0.2;
    rotEv2.setValue(rot2);
    ExtStim es = getmaxpond((int)1);
    if (verbose) {
      output.appendText("Approaching food at "+String.valueOf(es.x)+", "+String.valueOf(es.z)+"...\n");
    }
    approach(es.x,es.z);
  }
  
  void runawayfromblob() {
    rot2[0] = 1; rot2[1] = 0; rot2[2] = 0; rot2[3] = (float)-0.4;
    rotEv2.setValue(rot2);
    ExtStim es = getmaxpond((int)8);
    if (verbose) {
      output.appendText("Running away from blob at "+String.valueOf(es.x)+", "+String.valueOf(es.z)+"...\n");
    }
    runaway(es.x,es.z); 
  }
  
  boolean inwall(float x, float z) {
    int i;
    ExtStim es;
    boolean aja = false;
    float z1,z2,x1,x2;
    for(i = 0;i < SimFrame.env.wallvp.size();i++) {
      es = (ExtStim) SimFrame.env.wallvp.elementAt(i);
      z1 = (float)es.z-(es.s2/2);
      z2 = (float)es.z+(es.s2/2);
      x1 = (float)es.x-(es.s/2);
      x2 = (float)es.x+(es.s/2);
      if((z1 <= z)&&(z <= z2)&&(x1 <= x)&&(x <= x2)) {
        aja = true;
      }
    }
    return aja;
  }
  
  void checkwall() {
    float goma = 0;
    while(inwall(pos[0],pos[2])) {
      goma+= (float)0.15;//turnalfa&beta(goma*str) for follow edges
      avoidalfa+= (float)0.15;
      avoidbeta+= (float)0.15;
      pos[0] = pos2[0];pos[2] = pos2[2];
      //rot[3]=rot3[3];
      if (avoidalfa < 0.01) avoidalfa+= (float)0.2;
      if (avoidbeta < 0.01) avoidbeta+= (float)0.2;
      if ((syncstep%2) == 0) {
        turnAlfa(avoidalfa*strength);
      } else {
        turnBeta(avoidbeta*strength);
      }
    }
  }
  
  void show(double[] arr,String str) {
    int i;
    output.appendText(str+": ");
    for (i = 0;i < a.CS;i++) {
      output.appendText(arr[i]+" ");
    }
    output.appendText("\n");
  }
  
  void showsq(double[][] arr,String str) {
    int i,j;
    output.appendText(str+": ");
    for (i = 0;i < a.CS;i++) {
      for (j = 0;j < a.CS;j++) {
        output.appendText(arr[i][j]+" ");
      }
      output.appendText("\n");
    }
  }
  
  void actions() {
    int i;
    explo = avd = false;
    for(i = 0;i < a.CS;i++) {
      if(a.nc.CG[i] > 0) {
        switch (i) {
          case 0:if ((a.nm.cwinner > 0)&&(ArqColsCond.phi > 0)) {
            explore();
            explo = true;
          } else {
            wander();
          } break;
          case 1:approachgrass(); break;
          case 2:approachfood(); break;
          case 3:feed(); break;
          case 4:approachwater(); break;
          case 5:drink(); break;
          case 6:approachfw(); break;
          case 7:rest(); break;
          case 8:runawayfromblob(); break;
          case 20:avoid();
          avd = true;
          break;
        }
      }
    }
  }
  
  void go() {
    
    if (strength > 0) {
      died=false;
    }    
    if (!died){
    syncstep++;
    pos2[0] = pos[0];pos2[1] = pos[1];pos2[2] = pos[2];
    rot3[3] = rot[3] = (float)(((rot[3]+(3*Math.PI))%(2*Math.PI))-(Math.PI));
    if(verbose) {
      output.appendText("Animat at: "+String.valueOf(pos[0])+", "+String.valueOf(pos[2])+"; orientation: "+String.valueOf(rot[3])+"\n");
    }
    percep();
    
    if (explo)
      a.init(0);
    else
      if(avd)
        a.init(1);
      else
        a.init(2);
    a.nc.ES[1] = getmaxpondval((int)11)+getmaxpondval((int)12);//approachgrass
    a.nc.ES[2] = getmaxpondval((int)1)+getmaxpondval((int)4);//approachfood
    a.nc.ES[3] = getmaxpondval((int)4);//feed
    a.nc.ES[4] = getmaxpondval((int)2)+getmaxpondval((int)5);//approachwater
    a.nc.ES[5] = getmaxpondval((int)5);//drink
    a.nc.ES[6] = getmaxpondval((int)7)/*+getmaxpondval((int)5)+getmaxpondval((int)4)*/;//approachf&w
    a.nc.ES[7] = getmaxpondval((int)12);//rest
    a.nc.ES[8] = getmaxpondval((int)8);//runawayfromblob
    a.nc.ES[12] = getmaxpondval((int)9);//NS red spot
    a.nc.ES[13] = getmaxpondval((int)10);//NS yellow spot
    a.nc.ES[20] = getmaxpondval((int)6);//reflex avoid wall
    a.nm.MI[0] = 0.8;
    a.nm.MI[1] = fatigue;
    a.nm.MI[2] = thirst;
    a.nm.MI[3] = hunger;
    a.nm.MI[4] = (thirst+hunger)*5/8;
    a.nm.MI[5] = safety;
    a.go();
    actions();
    
    checkwall();//semipatch
    
    if( ! immortality) {
      if (strength <= 0) {
        died=true;
        output.appendText("Animat " + id + " died! ...requiescat in pace\n");
      } 
      if(fatigue > 0.8) {
        strength-= 0.006;
        lucidity-= 0.006;
      }
      if(thirst > 0.8) {
        strength-= 0.002;
        lucidity-= 0.002;
      }
      if(hunger > 0.8) {
        strength-= 0.001;
        lucidity-= 0.001;
      }
    }
    if(fatigue < 0.2) {
      strength+= 0.006;
      lucidity+= 0.006;
    }
    if(thirst < 0.2) {
      strength+= 0.002;
      lucidity+= 0.002;
    }
    if(hunger < 0.2) {
      strength+= 0.001;
      lucidity+= 0.001;
    }
    if (strength > 1)strength = 1;
    if (lucidity > 1)lucidity = 1;
    if (fatigue < 0)fatigue = 0;
    if (thirst < 0)thirst = 0;
    if (hunger < 0)hunger = 0;

    if (showblack) {
      show(a.nc.ES,"ES");
      show(a.nm.MI,"MI");
      show(a.nc.CG,"CG");
      show(a.nc.p.PercExt,"PercExt");
      show(a.nc.p.PersPerc,"PersPerc");
      show(a.nc.p.PrefCons,"PrefCons");
      show(a.nc.p.CongDrvPerc,"CongDrvPerc");
      show(a.nc.p.AccPot,"AccPot");
      show(a.nc.p.Acc,"Acc");
      show(a.nm.p.PercInt,"PercInt");
      show(a.nm.p.PercExt,"PercExt");
      show(a.nm.p.CongPropExtDrv,"CongPropExtDrv");
      show(a.nm.p.Drv,"Drv");
    }
    if (showcoup) {
      showsq(a.nc.fa.SCE4,"SCE4");
      showsq(a.nm.fa.CPED2,"CPED2");
      showsq(a.nc.fa.AP3,"AP3"); 
    }
    fatigue+= 0.00006;
    thirst+= 0.0002;
    hunger+= 0.00012;
    
    color2[0] = color[0];
    color2[1] = color[1];
    color2[2] = color[2];
    //set colors in relation of internal states
    color[0] = (float)fatigue; 
    color[1] = (float)hunger;
    color[2] = (float)thirst;
    if (trailf) {
      addtrail();
    }
    update(true);
    }
  }

  public void update(boolean insim){
    strengthbar.setValue(Math.round(strength*100));
    luciditybar.setValue(Math.round(lucidity*100));
    safetybar.setValue(Math.round(safety*100));
    fatiguebar.setValue(Math.round(fatigue*100));
    thirstbar.setValue(Math.round(thirst*100));
    hungerbar.setValue(Math.round(hunger*100));
    if (verbose||(!insim)) {
      anx.setText(String.valueOf(Math.rint(10*pos[0])/10));
      anz.setText(String.valueOf(Math.rint(10*pos[2])/10));
      anth.setText(String.valueOf(Math.rint(100*rot[3])/100));
      rpf.setText(String.valueOf(Math.rint(100*rp)/100));
    }
    posEv.setValue(pos);
    rotEv.setValue(rot);
    /*if (verbose){
      diffuseColorC.setValue(color);
      diffuseColorS.setValue(color);
      diffuseColorT.setValue(color);
    }*/
  }
  
  public void destroy() {
    int i;
    for (i = 0;i < trailvec.size();i++) {
      rmTrailCh.setValue((Node[])trailvec.elementAt(i));
    }
    trailvec.removeAllElements();
    pos[0] = 0;
    pos[2] = 0;
    rot[3] = 0;
    posEv.setValue(pos);
    rotEv.setValue(rot);
    this.hide();
    logo=null;
    dispose();
  }
  
}