//Arquitectura de Columnas Conductuales
//Pedro Pablo Gonzlez
//ppgp@servidor.unam.mx
//Carlos Gershenson
//carlos@jlagunez.iquimica.unam.mx

import java.util.Vector;
import java.io.*;

class REACAccRef implements Serializable{//Acciones reflejas
    int id;
    double Am,Om;
    void show(){
        System.out.println("ID: "+id+" Om: "+Om+" Am: "+Am);
    }
}

class REACPersPerc implements Serializable{//Persistencia perceptual
    int id;
    double Os,Ot,Oi,At,Otn;
    void show(){
        System.out.println("ID: "+id+" Os: "+Os+" Ot: "+Ot+" Oi: "+Oi+" At: "+At+" Otn: "+Otn);
    }
}

class REACAtenPref implements Serializable{//Atencin a preferencias
    int id;
    double Ot,Oi;
    void show(){
        System.out.println("ID: "+id+" Ot: "+Ot+" Oi: "+Oi);
    }
}

class REACInRespRef implements Serializable{//Inhibicin de Respuestas Reflejas
    int id;
    double Ot,Ah,Oh;
    void show(){
        System.out.println("ID: "+id+" Ot: "+Ot+" Oh: "+Oh+" Ah: "+Ah);
    }
}

class REACSelCondExt implements Serializable{//Seleccin de Conductas Externas
    int id;
    double Am,Om;
    void show(){
        System.out.println("ID: "+id+" Om: "+Om+" Am: "+Am);
    }
}

class REACSelPrefCons implements Serializable{//Selector de preferencias consumatorias
    int id;
    double Oc,Od,Ad;
    void show(){
        System.out.println("ID: "+id+" Oc: "+Oc+" Od: "+Od+" Ad: "+Ad);
    }
}

class BME implements Serializable{//Buzn de mensajes de entrada
    int idse,idcond;
    double Ose;
}

class FzaApCog implements Serializable{
    double[] E0= {0,0.87,0.93,0.96,0.94,0.97,0.95,0.9,0.98,0,0,0,0.92,0.91,0,0,0,0,0,0,1,0,0,0};
    double[] AR1= {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1};
    double[] PP1={0,0.87,0.93,0.96,0.94,0.97,0.95,0.9,0.98,0,0,0,0.92,0.91,0,0,0,0,0,0,1,0,0,0};
    double[][] PP2= new double[ArqColsCond.CS][ArqColsCond.CS];
    double[] PP4={0,0.87,0.93,0.96,0.94,0.97,0.95,0.9,0.98,0,0,0,0.92,0.91,0,0,0,0,0,0,1,0,0,0};
    double[] AP2= {1,1.02,1.08,1.11,1.09,1.12,1.10,1.05,1.13,1,1,1,1.07,1.06,1,1,1,1,1,1,1,1,1,1};
    double[][] AP3= new double[ArqColsCond.CS][ArqColsCond.CS];
    double[] IRR2= {1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1};
    double[][] IRR4= new double[ArqColsCond.CS][ArqColsCond.CS];
    double[] IRR4d= new double[ArqColsCond.CS];
    double IRR3d=1;
    double[][] SCE4= new double[ArqColsCond.CS][ArqColsCond.CS];
    double[][] SCE5= new double[ArqColsCond.CS][ArqColsCond.CS];
    double[] A6= {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
    
    public FzaApCog(){
        int i,j;
        for (i=0;i<ArqColsCond.CS;i++){
            for (j=0;j<ArqColsCond.CS;j++){
                AP3[j][i]=0.0;
                if (i==j){
                    PP2[i][j]=0;
                    IRR4[i][j]=1;
                    SCE4[i][j]=3;
                    SCE5[i][j]=1;
                }else{
                    PP2[i][j]=-0.15;
                    IRR4[i][j]=-8;
                    SCE4[i][j]=0;
                    SCE5[i][j]=0;
                }
            }
            for(j=(ArqColsCond.condi);j<ArqColsCond.refi;j++){
              AP3[j][i]=0.001;
            }
            IRR4d[i]=-10;
        }
        for(i=(ArqColsCond.condi);i<ArqColsCond.refi;i++){
            for (j=0;j<ArqColsCond.CS;j++){
                if (j!=ArqColsCond.k)
                    if (i==j){
                        SCE4[i][j]=0;
                        SCE5[i][j]=0;
                    }else{
                        PP2[i][j]=-1;
                        SCE4[j][i]=0.001;
                    }
            }
            IRR4d[i]=-1;
        }
        AP3[0][1]=1;
        AP3[0][2]=1;
        AP3[0][3]=1;
        AP3[0][4]=1;
        AP3[1][1]=1;
        AP3[2][3]=1;
        AP3[3][3]=1;
        AP3[4][2]=1;
        AP3[5][2]=1;
        AP3[6][4]=1;
        AP3[7][1]=1;
        AP3[8][5]=1;
        SCE4[3][3]=9;
        SCE4[5][5]=9;
        SCE4[7][7]=9;
    }
}

class FzaApMot implements Serializable{
    double[] P0= {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
    double[] CPED1= {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
    double[][] CPED2= new double[ArqColsCond.CS][ArqColsCond.CS];
    double[] CPED4= {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
    double[][] SPC3= new double[ArqColsCond.CS][ArqColsCond.CS];

    public FzaApMot(){
        int i,j;
        for (i=0;i<ArqColsCond.CS;i++){
            for (j=0;j<ArqColsCond.CS;j++){
                if (i==j){
                    SPC3[i][j]=1;
                }else{
                    SPC3[i][j]=-0.15;
                }
            }
            for(j=(ArqColsCond.condi);j<ArqColsCond.refi;j++){
                CPED2[i][j]=0.001;
            }
        }       
        CPED2[1][0]=1;
        CPED2[1][1]=1;
        CPED2[1][7]=1;
        CPED2[2][0]=1;
        CPED2[2][4]=1;
        CPED2[2][5]=1;
        CPED2[3][0]=1;
        CPED2[3][2]=1;
        CPED2[3][3]=1;
        CPED2[4][0]=1;
        CPED2[4][6]=1;
        CPED2[5][8]=1;
    }
}

class PizCog implements Serializable{
    double[] PercExt= new double[ArqColsCond.CS];
    double[] PersPerc= new double[ArqColsCond.CS];
    double[] PrefCons= new double[ArqColsCond.CS];
    double[] CongDrvPerc= new double[ArqColsCond.CS];
    double[] AccPot= new double[ArqColsCond.CS];
    double[] Acc= new double[ArqColsCond.CS];
}

class PizMot implements Serializable{
    double[] PercInt= new double[ArqColsCond.CS];
    double[] PercExt= new double[ArqColsCond.CS];
    double[] CongPropExtDrv= new double[ArqColsCond.CS];
    double[] Drv= new double[ArqColsCond.CS];
}

class NodoCog implements Serializable{
    PizCog p= new PizCog();
    double[] ES= new double[ArqColsCond.CS];
    double[] CG= new double[ArqColsCond.CS];//conducta(s) ganadora(s)
    Vector LREACAR= new Vector (10,(int)3);
    Vector LREACPP= new Vector (10,(int)3);
    Vector LREACAP= new Vector (10,(int)3);
    Vector LREACIRR= new Vector (10,(int)3);
    Vector LREACSCE= new Vector (10,(int)3);
    Vector buzon= new Vector (10,(int)3);
    FzaApCog fa= new FzaApCog();
    
    void showLPP(){
        int i;
        REACPersPerc r;
        for (i=0;i<LREACPP.size();i++){
            System.out.print("pos: "+i+" ");
            r=(REACPersPerc)LREACPP.elementAt(i);
            r.show();
        }
    }
    void showLAP(){
        int i;
        REACAtenPref r;
        for (i=0;i<LREACAP.size();i++){
            System.out.print("pos: "+i+" ");
            r=(REACAtenPref)LREACAP.elementAt(i);
            r.show();
        }
    }
    void showLIRR(){
        int i;
        REACInRespRef r;
        for (i=0;i<LREACIRR.size();i++){
            System.out.print("pos: "+i+" ");
            r=(REACInRespRef)LREACIRR.elementAt(i);
            r.show();
        }
    }
    void showLSCE(){
        int i;
        REACSelCondExt r;
        for (i=0;i<LREACSCE.size();i++){
            System.out.print("pos: "+i+" ");
            r=(REACSelCondExt)LREACSCE.elementAt(i);
            r.show();
        }
    }

    void exteroceptores(){
        int i;
        for (i=0;i<ArqColsCond.CS;i++){
            if (ES[i]!=0){
                p.PercExt[i]=fa.E0[i]*ES[i];
            }
        }
    }
    void persperc(int accion, int id, double Ot){
        int i;
        double v1,v2,v3;
        REACPersPerc r;
        switch(accion){
            case 1:{
                LREACPP.removeAllElements();
                for(i=0;i<ArqColsCond.CS;i++){
                    v1=p.PercExt[i];
                    v2=p.PersPerc[i];
                    v3=p.CongDrvPerc[i];
                    if((v1!=0)||(v2!=0)||(v3!=0)){
                        r= new REACPersPerc();
                        r.id=i;
                        r.Os=v1;
                        r.Ot=v2;
                        r.Oi=v3;
                        LREACPP.addElement(r);
                    }
                }
                break;
            }case 2:{
                p.PersPerc[id]=Ot;
                break;
            }
        }
    }
    boolean atenpref(int accion, int id, double Oi){
        int i,j;
        boolean preactivado=false;
        double vi=0,v3,v2,v1;
        double gamma=ArqColsCond.gamma,phi=ArqColsCond.phi;
        REACAtenPref r;
        switch(accion){
            case 1:{
                LREACAP.removeAllElements();
                for(i=0;i<ArqColsCond.CS;i++){
                    v1=p.PercExt[i];
                    v2=p.PersPerc[i];
                    if((v2>0)&&(v1>0)){
                        vi=0;
                        for(j=0;j<ArqColsCond.CS;j++){
                            v3=p.PrefCons[j];
                            vi+=fa.AP3[i][j]*v3;
                        }
                        //vi=Math.min(fa.AP2[i]*v2,vi);
                        vi=fa.AP2[i]*v2*(gamma+(phi*vi/v2));
                        if (vi>0){
                            if ((i<ArqColsCond.condi)&&(gamma<=0.0)&&(vi>ArqColsCond.umbralAPpreac))
                                preactivado=true;
                            r= new REACAtenPref();
                            r.id=i;
                            r.Oi=vi;
                            LREACAP.addElement(r);
                        }
                    }
                }
                break;
            }case 2:{
                p.CongDrvPerc[id]=Oi;
                break;
            }
        }
        return preactivado;
    }
    void inrespref(int accion, int id, double Oh){
        int i,j;
        double prem1,prem2;
        double sumap, Ah,v2,v4;
        REACInRespRef r;
        switch(accion){
            case 1:{
                LREACIRR.removeAllElements();
                for(i=0;i<ArqColsCond.CS;i++){
                    v2=p.PersPerc[i];
                    prem1=prem2=0;
                    if(v2!=0){               
                        prem1=1;
                    }
                    for(j=0;j<ArqColsCond.CS;j++){
                        v4=p.CongDrvPerc[j];
                        if(v4!=0){
                            prem2=1;
                        }                        
                    }
                    if ((prem1*(ArqColsCond.gammaold+prem2))>0){
                        sumap=0;
                        for(j=0;j<ArqColsCond.CS;j++){
                            sumap+=fa.IRR4[i][j]*p.CongDrvPerc[j];
                        }
                        Ah=(fa.IRR2[i]*v2)+sumap;
                        if (Ah>0){
                            r= new REACInRespRef();
                            r.id=i;
                            r.Ah=Ah;
                            LREACIRR.addElement(r);
                        }                    
                    }
                }
                break;
            }case 2:{
                p.AccPot[id]=Oh;
                break;
            }
        }
    }
    void CIEdefIRR(int accion, int id, double Oh){// hay que checar
        int i,j,k=ArqColsCond.k;
        boolean prem1=false,prem2=false;
        double sumap, Ah,v3,v4;
        REACInRespRef r;
        switch(accion){
            case 1:{
                v3=p.PrefCons[k];
                prem1=prem2=false;
                if(v3!=0){
                    prem1=true;
                }
                for(j=0;j<ArqColsCond.CS;j++){
                    v4=p.CongDrvPerc[j];
                    if(v4!=0){
                        prem2=true;
                    }                        
                }
                if (prem1||prem2){
                    sumap=0;
                    for(j=0;j<ArqColsCond.CS;j++){
                        sumap+=fa.IRR4d[j]*p.CongDrvPerc[j];
                    }
                    Ah=(fa.IRR3d*v3)+sumap;
                    if (Ah>0){
                        r= new REACInRespRef();
                        r.id=k;
                        r.Ah=Ah;
                        LREACIRR.addElement(r);                    
                    }
                }
                break;
            }case 2:{
                p.AccPot[id]=Oh;
                break;
            }
        }
    }
    void selcondext(int accion, int id, double Om){
        int i,j,k=ArqColsCond.k;
        double sumap1,sumap2, Am,v5,v4;
        REACSelCondExt r;
        switch(accion){
            case 1:{
                LREACSCE.removeAllElements();
                for(i=0;i<ArqColsCond.CS;i++){
                    sumap1=sumap2=0;
                    for(j=0;j<ArqColsCond.CS;j++){
                        v4=p.CongDrvPerc[j];
                        v5=p.AccPot[j];
                        sumap1+=fa.SCE4[i][j]*v4;
                        sumap2+=fa.SCE5[i][j]*v5;
                    }
                    Am=sumap1+sumap2;
                    if (Am>0){
                        r= new REACSelCondExt();
                        r.id=i;
                        r.Am=Am;
                        LREACSCE.addElement(r);
                    }
                }
                break;
            }case 2:{
                p.Acc[id]=Om;
                break;
            }
        }
    }
    boolean accref(int accion, int id, double Om){
        int i;
        boolean aja=false;
        double v1,Am;
        REACAccRef r;
        switch(accion){
            case 1:{
                LREACAR.removeAllElements();
                aja=false;
                for(i=ArqColsCond.refi;i<ArqColsCond.CS;i++){
                  v1=p.PercExt[i];
                  Am=v1*fa.AR1[i];
                  if (Am>0){
                    aja=true;
                    r= new REACAccRef();
                    r.id=i;
                    r.Am=Am;
                    LREACAR.addElement(r);
                  }
                }
                break;
            }case 2:{
                aja=true;
                p.Acc[id]=Om;
                break;
            }
        }
        return aja;
    }
    void actuadores(){
        int i;
        double v6;
        for(i=0;i<ArqColsCond.CS;i++){
            v6=p.Acc[i];
            CG[i]=fa.A6[i]*v6;
        }
    }
    void receptor(){
        int i;
        BME b;
        for (i=0;i<buzon.size();i++){
            b=(BME)buzon.elementAt(i);
            p.PrefCons[b.idse]=b.Ose;
        }
    }
    Vector transmisor(){
        int i;
        double v2,v1;
        Vector v=new Vector((int)10,(int)3);
        BME b;
        for (i=0;i<ArqColsCond.CS;i++){
            v2=p.PersPerc[i];
            v1=p.PercExt[i];
            if ((v2>0)&&(v1>0)){
                b=new BME();
                b.idse=b.idcond=i;
                b.Ose=v2;
                v.addElement(b);
            }
        }
        return v;
    }
    void selREACSPP(){
        int i,j;
        double sumap,k1=ArqColsCond.kappa;
        REACPersPerc r,r2;
        for(i=0;i<LREACPP.size();i++){
            r=(REACPersPerc)LREACPP.elementAt(i);
            sumap=0;
            for (j=0;j<LREACPP.size();j++){
                r2=(REACPersPerc)LREACPP.elementAt(j);
                sumap+=fa.PP2[r.id][r2.id]*r2.Ot;
            }
            r.At=((1-k1)*r.Ot)+(fa.PP1[r.id]*r.Os)+(fa.PP4[r.id]*r.Oi)+sumap;
            if(r.At>ArqColsCond.umbralPP){
                if ((fa.PP1[r.id]*r.Os)>0)
                  r.Otn=(-1/(r.At+(1/ArqColsCond.maxPP[r.id])))+ArqColsCond.maxPP[r.id];
                else
                  r.Otn=r.At;
            }else{
                r.Otn=0;
            }
            persperc(2,r.id,r.Otn);
        }
    }
    void selREACSAP(){
        int i;
        double umbral=ArqColsCond.umbralAP;
        REACAtenPref r;
        for(i=0;i<LREACAP.size();i++){
            r=(REACAtenPref)LREACAP.elementAt(i);
            if(r.Oi>umbral){
                atenpref(2,r.id,r.Oi);
            }
        }
    }
    void selREACSIRR(){
        int i;
        REACInRespRef r;
        for(i=0;i<LREACIRR.size();i++){
            r=(REACInRespRef)LREACIRR.elementAt(i);
            if(r.Ah>0){
                r.Oh=r.Ah;
            }else{
                r.Oh=0;
            }
            inrespref(2,r.id,r.Oh);
        }
    }
    void selREACSSCE(){
        int i,pos=0;
        double max=0, umbral=ArqColsCond.umbralSCE;
        REACSelCondExt r;
        for(i=0;i<LREACSCE.size();i++){
            r=(REACSelCondExt)LREACSCE.elementAt(i);
            if(r.Am>umbral){
                if(r.Am>max){
                    pos=i;
                    max=r.Am;
                }
            }
        }
        r=(REACSelCondExt)LREACSCE.elementAt(pos);
        selcondext(2,r.id,1);
    }
    void selREACSAR(){
        int i,pos=0;
        double max=0;
        REACAccRef r;
        for(i=0;i<LREACAR.size();i++){
            r=(REACAccRef)LREACAR.elementAt(i);
            if(r.Am>0){
                if(r.Am>max){
                    pos=i;
                    max=r.Am;
                }
            }
        }
        r=(REACAccRef)LREACAR.elementAt(pos);
        accref(2,r.id,1);
    }
    void refFASCE(){
        int i,j,j2;
        double v4,v6,v42;
        for(i=0;i<ArqColsCond.CS;i++){
            v6=p.Acc[i];
            if((v6>0)&&(i!=ArqColsCond.k)){
                v42=0;
                for(j2=0;j2<ArqColsCond.CS;j2++){
                  if(i!=j2)
                    v42+=p.CongDrvPerc[j2]*fa.SCE4[i][j2];
                  }
                for(j=(ArqColsCond.condi);j<ArqColsCond.refi;j++){
                    v4=p.CongDrvPerc[j];
                    if (v4>0){
                      if(v42>0)
                        fa.SCE4[i][j]=((1-ArqColsCond.beta)*fa.SCE4[i][j])+(v4*v6*ArqColsCond.lambda*ArqColsCond.fSCE);
                      else
                        fa.SCE4[i][j]=((1-ArqColsCond.mu)*fa.SCE4[i][j]);
                      if (fa.SCE4[i][j]>3) fa.SCE4[i][j]=3;
                      if (fa.SCE4[i][j]<0.001) fa.SCE4[i][j]=0.001;
                    }
                }
            }
        }
    }
    void refFAAP(){
        int i,j,j2;
        double v4,v3,v42;
        for(i=(ArqColsCond.condi);i<ArqColsCond.refi;i++){
            v4=p.CongDrvPerc[i];
            if (v4>0){
              for(j=0;j<ArqColsCond.CS;j++){
                v42=0;
                for(j2=0;j2<ArqColsCond.CS;j2++){
                  if(i!=j2)
                    v42+=p.CongDrvPerc[j2]*fa.AP3[j2][j];
                }
                v3=p.PrefCons[j];
                if ((j!=ArqColsCond.k)){
                  if((v42>0))
                    fa.AP3[i][j]=((1-ArqColsCond.beta)*fa.AP3[i][j])+(v4*v3*ArqColsCond.lambda*ArqColsCond.fAP);
                  else
                    fa.AP3[i][j]=((1-ArqColsCond.mu)*fa.AP3[i][j]);
                  if (fa.AP3[i][j]>1) fa.AP3[i][j]=1;
                  if (fa.AP3[i][j]<0.001) fa.AP3[i][j]=0.001;
                }
              }
            }
        }
    }
    void updatelateralinhibition(){
      int i,j;
      double max=0;
      for (j=ArqColsCond.condi;j<ArqColsCond.refi;j++){
        max=0;
        for (i=0;i<ArqColsCond.condi;i++){
          if (fa.SCE4[i][j]>max){
            max=fa.SCE4[i][j];
          }
        }
        for (i=0;i<ArqColsCond.CS;i++){
          if ((i!=ArqColsCond.k)&&(i!=j)){
            if (max>=1)
              fa.PP2[j][i]=-0.15;
            else
              fa.PP2[j][i]=(0.85*max)-1;
          }
        }
      }
    }

}

class NodoMot implements Serializable{
    PizMot p=new PizMot();
    double[] MI= new double[ArqColsCond.CS];
    Vector LREACSPC= new Vector (10,(int)3);
    Vector buzon= new Vector (10,(int)3);
    FzaApMot fa= new FzaApMot();
    int cwinner=ArqColsCond.CS;
    
    void showLSPC(){
        int i;
        REACSelPrefCons r;
        for (i=0;i<LREACSPC.size();i++){
            System.out.print("pos: "+i+" ");
            r=(REACSelPrefCons)LREACSPC.elementAt(i);
            r.show();
        }
    }
    
    void propioceptores(){
        int i;
        for (i=0;i<ArqColsCond.CS;i++){
            if (MI[i]!=0){
                p.PercInt[i]=MI[i]*fa.P0[i];
            }
        }
    }
    void propextdrv(){
        int i,j,k=ArqColsCond.k;
        double sumap,Ac,v1,v2,v4,alfa=ArqColsCond.alfa;
        for(i=0;i<ArqColsCond.CS;i++){
            v1=p.PercInt[i];
            v4=p.Drv[i];
            if(i!=k){
                sumap=0;
                for(j=0;j<ArqColsCond.CS;j++){
                    v2=p.PercExt[j];
                    sumap+=fa.CPED2[i][j]*v2;
                }
                Ac=(fa.CPED1[i]*v1*(alfa+sumap))+(fa.CPED4[i]*v4);
                p.CongPropExtDrv[i]=Ac;
            }
            else{
                Ac=fa.CPED1[i]*v1;
                p.CongPropExtDrv[i]=Ac;
            }
        }
    }
    void selprefcons(int accion, int id, double Od){
        int i;
        double v3,umbral;
        REACSelPrefCons r;
        switch(accion){
            case 1:{
                LREACSPC.removeAllElements();
                for(i=0;i<ArqColsCond.CS;i++){
                    v3=p.CongPropExtDrv[i];
                    umbral=ArqColsCond.umbralSPC[i];
                    if(v3>umbral){ 
                        r= new REACSelPrefCons();
                        r.id=i;
                        r.Oc=v3;
                        LREACSPC.addElement(r);
                    }
                }
                break;
            }case 2:{
                p.Drv[id]=Od;
                break;
            }
        }
    }
    void receptor(){
        int i;
        BME b;
        for (i=0;i<buzon.size();i++){
            b=(BME)buzon.elementAt(i);
            p.PercExt[b.idse]=b.Ose;
        }
    }
    Vector transmisor(){
        int i;
        double v4;
        Vector v=new Vector((int)10,(int)3);
        BME b;
        for (i=0;i<ArqColsCond.CS;i++){
            v4=p.Drv[i];
            if (v4!=0){
                b=new BME();
                b.idse=b.idcond=i;
                b.Ose=v4;
                v.addElement(b);
            }
        }
        return v;
    }
    void selREACSSPC(){
        p.Drv=new double[ArqColsCond.CS];
        int i,j,k=ArqColsCond.k;
        double sumap;
        REACSelPrefCons r,r2;
        cwinner=0;
        for(i=0;i<LREACSPC.size();i++){
            r=(REACSelPrefCons)LREACSPC.elementAt(i);
            if (r.id!=k){
                sumap=0;
                for (j=0;j<LREACSPC.size();j++){
                    r2=(REACSelPrefCons)LREACSPC.elementAt(j);
                    sumap+=fa.SPC3[r.id][r2.id]*r2.Oc;
                }
                r.Ad=sumap;
                if(r.Ad>0){
                    r.Od=r.Ad;
                    cwinner++;
                }else{
                    r.Od=0;
                }
            }
        }
        if (cwinner<=1){
            for(i=0;i<LREACSPC.size();i++){
                r=(REACSelPrefCons)LREACSPC.elementAt(i);
                if (r.id==k){
                    selprefcons(2, r.id, r.Oc);
                }
            }
        }
        if (cwinner>=1){
            for(i=0;i<LREACSPC.size();i++){
                r=(REACSelPrefCons)LREACSPC.elementAt(i);
                if (r.Od>0){
                    selprefcons(2, r.id, r.Od);
                }
            }        
        }
    }
    void refFACPED(){
        int i,j,j2;
        double v4,v2,v22;
        for(i=0;i<ArqColsCond.CS;i++){
            v4=p.Drv[i];
            if((v4>0)&&(i!=ArqColsCond.k)){
                for(j=(ArqColsCond.condi);j<ArqColsCond.refi;j++){
                    v2=p.PercExt[j];
                    if (v2>0){
                      v22=0;
                      for(j2=0;j2<ArqColsCond.CS;j2++){
                        if(j2!=j)
                          v22+=p.PercExt[j2]*fa.CPED2[i][j2];
                      }
                      if(v22>0)
                        fa.CPED2[i][j]=((1-ArqColsCond.beta)*fa.CPED2[i][j])+(v4*v2*ArqColsCond.lambda*ArqColsCond.fCPED);
                      else
                        fa.CPED2[i][j]=((1-ArqColsCond.mu)*fa.CPED2[i][j]);
                      if (fa.CPED2[i][j]>1) fa.CPED2[i][j]=1;
                      if (fa.CPED2[i][j]<0.001) fa.CPED2[i][j]=0.001;
                    }
                }
            }
        }
    }

}

public class ArqColsCond implements Serializable{
    NodoCog nc=new NodoCog();
    NodoMot nm=new NodoMot();
    static final int CS=24;//cantidad de seales por nivel
    static final int condi=12;//pos donde empiezan estmulos condicionados
    static final int refi=20;//pos donde empiezan estmulos reflejos
    static final int k=0;//indice de la conducta por defecto;
    static double alfa=0.8;
    static double beta=0.001;//factor de aprendizaje
    static double lambda=0.1;//factor de aprendizaje
    static double kappa=0.25;//factor de prdida en persistencia perceptual
    static double mu=0.02;//factor de desaprendizaje
    static double gamma=0;
    static double phi=1;
    static double gammaold=0;
    static double fCPED=0.01;
    static double fAP=5;
    static double fSCE=30;
    static final double umbralAP=0.001; 
    static final double umbralAPpreac=0.1; 
    static final double umbralSCE=0.2; 
    static final double umbralPP=0.001;
    static final double[] maxPP={3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,1,1,1,1};;
    static double[] umbralSPC= {0.2,0.2,0.2,0.2,0.2,ArqColsCond.alfa+0.1,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2};
   
    void setalfa(double newalfa){
        alfa=newalfa;
        if(alfa>0.2)
            umbralSPC[5]= alfa+0.1;
        else
            umbralSPC[5]= 0.2;
    }
    int getmaxNS(){
        int i, max=0;
        double v4=0;
        for(i=(ArqColsCond.condi);i<ArqColsCond.refi;i++){
          if (nc.p.CongDrvPerc[i]>v4){
            v4=nc.p.CongDrvPerc[i];
            max=i;
          }
        }
        return max;
    }

    boolean checkpercs(){
      int i;
      double v1,v2;
      for (i=0;i<refi;i++){
        v1=nc.p.PercExt[i];
        v2=nc.p.PersPerc[i];
        if (v1>0)
          if (v2<=0)
            return true;
      }
      return false;
    }
    
    void init(int st){//st=0 si se acaba de ejecutar cond. por defecto con preactivacin (explora)
                      //st=1 si se acaba de ejecutar accin refleja
                      //st=2 en otro caso
        nm.p=new PizMot();
            nc.p.PercExt=new double[ArqColsCond.CS];
            nc.p.CongDrvPerc=new double[ArqColsCond.CS];
            nc.p.AccPot=new double[ArqColsCond.CS];
            nc.p.Acc=new double[ArqColsCond.CS];
            if (st!=0){
                nc.p.PrefCons=new double[ArqColsCond.CS];
        }
    }
    
    void go(){
        
//show(nc.fa.PP2[12],"red");
//show(nc.fa.PP2[13],"yell");
    
        nc.updatelateralinhibition();
        nc.exteroceptores();
        nc.persperc(1,0,0);
        nc.selREACSPP();
        if (!nc.accref(1,0,0)){
            if((!nc.atenpref(1,0,0))/*&&(checkpercs())*/){
                nm.buzon=nc.transmisor();
                nm.receptor();
                nm.propioceptores();
                nm.cwinner=ArqColsCond.CS;
                while (nm.cwinner>1){
                    nm.propextdrv();
                    nm.selprefcons(1,0,0);
                    nm.selREACSSPC();
                }
                nc.buzon=nm.transmisor();
                nc.receptor();
                nc.atenpref(1,0,0);
                if (nm.cwinner>0){
                  nm.refFACPED();
                }
            }
            nc.selREACSAP();
            nc.inrespref(1,0,0);
            nc.CIEdefIRR(1,0,0);
            nc.selREACSIRR();
            nc.selcondext(1,0,0);
/*if(alfa<=0.7){
        show(nc.p.PercExt,"PercExt");
        show(nc.p.PersPerc,"PersPerc");
        show(nc.p.PrefCons,"PrefCons");
        show(nc.p.CongDrvPerc,"CongDrvPerc");
        show(nc.p.AccPot,"AccPot");
        show(nc.p.Acc,"Acc");
        show(nm.p.PercInt,"PercInt");
        show(nm.p.PercExt,"PercExt");
        show(nm.p.CongPropExtDrv,"CongPropExtDrv");
        show(nm.p.Drv,"Drv");
}
*/            nc.selREACSSCE();
            if (nm.cwinner>0){
                nc.refFAAP();
                nc.refFASCE();
            }
        }else{
          nc.selREACSAR();
        }
        nc.actuadores();
    }
    
  void show(double[] arr,String str){
        int i;
        System.out.print(str+": ");
        for (i=0;i<CS;i++){
            System.out.print(arr[i]+" ");
        }
        System.out.println("");
    }
/*
    public ArqColsCond(){
        nc.ES[2]= 0.5;
        nc.ES[3]= 0.0;
        nc.ES[4]= 0.5;
        nc.ES[5]= 0.0;
        nc.ES[6]= 0.0;
        nc.ES[7]= 1;
        nc.ES[20]= 0;
        nm.MI[0]=1;
        nm.MI[1]=0.8;
        nm.MI[2]=0.5;
        nm.MI[3]=0.6;
        nm.MI[4]=0.55;
         show(nc.ES,"ES");
         show(nm.MI,"MI");
        nc.exteroceptores();
         show(nc.p.PercExt,"PercExt");
        nc.persperc(1,0,0);
         nc.showLPP();
        nc.selREACSPP();
         show(nc.p.PersPerc,"PersPerc");
        if (!nc.accref()){
            if(!nc.atenpref(1,0,0)){
                nm.buzon=nc.transmisor();
                nm.receptor();
                 show(nm.p.PercExt,"PercExt");
                nm.propioceptores();
                 show(nm.p.PercInt,"PercInt");
                nm.cwinner=ArqColsCond.CS;
                while (nm.cwinner>1){
                    nm.propextdrv();
                     show(nm.p.CongPropExtDrv,"CongPropExtDrv");
                    nm.selprefcons(1,0,0);
                     nm.showLSPC();
                    nm.selREACSSPC();
                     show(nm.p.Drv,"Drv");
                     try{ System.in.read(); }catch(java.io.IOException e){} 
                }
                nc.buzon=nm.transmisor();
                nc.receptor();
                 show(nc.p.PrefCons,"PrefCons");
                nc.atenpref(1,0,0);
            }
             nc.showLAP();
            nc.selREACSAP();
             show(nc.p.CongDrvPerc,"CongDrvPerc");
            nc.inrespref(1,0,0);
            nc.CIEdefIRR(1,0,0);
             nc.showLIRR();
            nc.selREACSIRR();
             show(nc.p.AccPot,"AccPot");
            nc.selcondext(1,0,0);
             nc.showLSCE();
            nc.selREACSSCE();
        }
         show(nc.p.Acc,"Acc");
        nc.actuadores();
         show(nc.CG,"CG");
        
        
    }    

    public static void main(String[] args) {
        System.out.println("Testing, testing....");
        ArqColsCond arq=new ArqColsCond();
    }
    */
}