//ASIA simulation
//Carlos Gershenson
//carlos@jlagunez.iquimica.unam.mx

import java.awt.*;
import java.io.*; 
import java.util.*;
import vrml.external.field.*;
import vrml.external.Node;
import vrml.external.Browser;
import vrml.external.exception.*;
import Environment;
import Animat;
import netscape.security.PrivilegeManager;

public class SimFrame extends Frame implements Runnable, EventOutObserver
{
  Animat a;
  EventOutSFTime touchTime = null;
  Node touch;
  
  final int maxanimats = 10;
  int selectedanimat =-1;
  Animat[] animats = new Animat[maxanimats]; //animats vector
  static Environment env = new Environment();
  static Browser browser;
  boolean error = false;
  Random rnd = new Random();
  TextArea output = null;
  Choice extStimCh;
  Checkbox esrnd;
  TextField esxf;
  TextField eszf;
  TextField essf;
  TextField essf2;
  TextField dly;
  Button start;
  
  static Node foods;
  static Node[] food;
  static EventInMFNode addFoodCh;
  static EventInMFNode rmFoodCh;
  static String foodstr = new String();
  static Vector foodvec = new Vector ((int)20,(int)3);
  static Node waters;
  static Node[] water;
  static EventInMFNode addWaterCh;
  static EventInMFNode rmWaterCh;
  static String waterstr = new String();
  static Vector watervec = new Vector ((int)20,(int)3);
  Node walls;
  Node[] wall;
  EventInMFNode addWallCh;
  EventInMFNode rmWallCh;
  String wallstr = new String();
  Vector wallvec = new Vector ((int)20,(int)3);
  Node blobs;
  Node[] blob;
  EventInMFNode addBlobCh;
  EventInMFNode rmBlobCh;
  String blobstr = new String();
  Vector blobvec = new Vector ((int)20,(int)3);
  Node rspots;
  Node[] rspot;
  EventInMFNode addRSpotCh;
  EventInMFNode rmRSpotCh;
  String rspotstr = new String();
  Vector rspotvec = new Vector ((int)20,(int)3);
  Node yspots;
  Node[] yspot;
  EventInMFNode addYSpotCh;
  EventInMFNode rmYSpotCh;
  String yspotstr = new String();
  Vector yspotvec = new Vector ((int)20,(int)3);
  Node grasses;
  Node[] grass;
  EventInMFNode addGrassCh;
  EventInMFNode rmGrassCh;
  String grassstr = new String();
  Vector grassvec = new Vector ((int)20,(int)3);
  long delay = 0;
  
  long t = 0;    //time
  static int SZ = 100; //size of one side of enviroment (which is square)
  Thread sim = null;
  boolean pause = true;
  boolean verbose = false;
  
  String saveFile = null; 
  String saveFileAn = null; 
  public Image logo = null;
  public MenuBar menu;
  public Menu simm, anm;
  public MenuItem resetm,rmanm,rmallm,savesimm,savesimasm,newanm,saveanm,saveanasm,loadsimm,loadanm;
  public CheckboxMenuItem svanimatsch;
  
  public SimFrame() {
    super ("Simulation Controls");
    try {
      PrivilegeManager.enablePrivilege("UniversalFileRead");
      logo = Toolkit.getDefaultToolkit().getImage("Asiaicon.gif");
      setIconImage(logo);
    } catch (netscape.security.ForbiddenTargetException e) {
      e.printStackTrace(System.err);
    }
    setFont(new Font("TimesRoman",Font.PLAIN,12));
    setBackground(Color.white);
    setLayout(new FlowLayout());
    menu = new MenuBar();
    simm = new Menu("Simulation");
    menu.add(simm);
    savesimm = new MenuItem("Save Simulation");
    simm.add(savesimm);
    savesimasm = new MenuItem("Save Simulation As...");
    simm.add(savesimasm);
    simm.addSeparator();
    loadsimm = new MenuItem("Load Simulation");
    simm.add(loadsimm);
    simm.addSeparator();
    resetm = new MenuItem("Reset Simulation");
    simm.add(resetm);
    simm.addSeparator();
    svanimatsch = new CheckboxMenuItem("Save Animats with Sim");
    simm.add(svanimatsch);
    anm = new Menu("Animat");
    menu.add(anm);
    newanm = new MenuItem("New Animat");
    anm.add(newanm);
    anm.addSeparator();
    saveanm = new MenuItem("Save Animat");
    anm.add(saveanm);
    saveanasm = new MenuItem("Save Animat As...");
    anm.add(saveanasm);
    anm.addSeparator();
    loadanm = new MenuItem("Load Animat");
    anm.add(loadanm);
    anm.addSeparator();
    rmanm = new MenuItem("Remove Animat");
    anm.add(rmanm);
    rmallm = new MenuItem("Remove All Animats");
    anm.add(rmallm);
    setMenuBar(menu);
    //
    newanm.disable();
    rmanm.disable();
    rmallm.disable();
    svanimatsch.setState(true);
    svanimatsch.disable();
    //
    start = new Button("Start ");
    add(start);
    add(new Button("Verbose"));
    add(new Button("Clear Output")); 
    add( new Label("Delay:"));
    dly = new TextField("0",4);
    add(dly);
    add(new Button("Set Dly"));
    output = new TextArea(5, 55);
    output.setEditable(false);
    output.setFont(new Font("TimesRoman",Font.PLAIN,12));
    add(output);
    extStimCh = new Choice();
    extStimCh.addItem("Food");
    extStimCh.addItem("Water");
    extStimCh.addItem("Grass");
    extStimCh.addItem("Wall");
    extStimCh.addItem("Blob");
    extStimCh.addItem("Red Spot");
    extStimCh.addItem("Yellow Spot");
    add(extStimCh);
    add( new Label("X:"));
    esxf = new TextField("0.0",3);
    add(esxf);
    add( new Label("Z:"));
    eszf = new TextField("15.0",3);
    add(eszf);
    add( new Label("S:"));
    essf = new TextField("2.0",3);
    add(essf);
    add( new Label("S2:"));
    essf2 = new TextField("2.0",3);
    add(essf2);
    esrnd = new Checkbox("Rnd",null,true);
    add(esrnd);
    add(new Button("Add ES"));
    add(new Button("Rmv ES"));
    resize(420,290);
    selectedanimat =-1;
    show();
    start();
  }
  
  public void start() {
    //
    a = new Animat("Aluata palliata I",t);
    //
    ExtStim es;
    output.appendText("\nStarting ASIA....\n");
    browser = (Browser) SimBase.browser;
    try {
      foods = browser.getNode("Foods");
      addFoodCh = (EventInMFNode) foods.getEventIn("addChildren");
      rmFoodCh = (EventInMFNode) foods.getEventIn("removeChildren");
      waters = browser.getNode("Waters");
      addWaterCh = (EventInMFNode) waters.getEventIn("addChildren");
      rmWaterCh = (EventInMFNode) waters.getEventIn("removeChildren");
      walls = browser.getNode("Walls");
      addWallCh = (EventInMFNode) walls.getEventIn("addChildren");
      rmWallCh = (EventInMFNode) walls.getEventIn("removeChildren");
      blobs = browser.getNode("Blobs");
      addBlobCh = (EventInMFNode) blobs.getEventIn("addChildren");
      rmBlobCh = (EventInMFNode) blobs.getEventIn("removeChildren");
      rspots = browser.getNode("RSpots");
      addRSpotCh = (EventInMFNode) rspots.getEventIn("addChildren");
      rmRSpotCh = (EventInMFNode) rspots.getEventIn("removeChildren");
      yspots = browser.getNode("YSpots");
      addYSpotCh = (EventInMFNode) yspots.getEventIn("addChildren");
      rmYSpotCh = (EventInMFNode) yspots.getEventIn("removeChildren");
      grasses = browser.getNode("Grasses");
      addGrassCh = (EventInMFNode) grasses.getEventIn("addChildren");
      rmGrassCh = (EventInMFNode) grasses.getEventIn("removeChildren");
      //
      initanimat();
      //
    }
    catch (InvalidNodeException e) {
      output.appendText("PROBLEMS!: " + e + "\n");
      error = true;
    }
    catch (InvalidEventInException e) {
      output.appendText("PROBLEMS!: " + e + "\n");
      error = true;
    }
    catch (InvalidEventOutException e) {
      output.appendText("PROBLEMS!: " + e + "\n");
      error = true;
    }
    catch (InvalidVrmlException e) {
      output.appendText("PROBLEMS!: " + e + "\n");
      error = true;
    }
    if (error == false) {
      es = new ExtStim(-(SZ/2)-1,0,(float)2,SZ,(int)3);
      env.wallvp.addElement(es);//add outer walls as obstacles
      es = new ExtStim((SZ/2)+1,0,(float)2,SZ,(int)3);
      env.wallvp.addElement(es);//add outer walls as obstacles
      es = new ExtStim(0,-(SZ/2)-1,SZ,(float)2,(int)3);
      env.wallvp.addElement(es);//add outer walls as obstacles
      es = new ExtStim(0,(SZ/2)+1,SZ,(float)2,(int)3);
      env.wallvp.addElement(es);//add outer walls as obstacles
    }
  }
  
  void initanimat() {
    a.ini();
    a.ani = browser.getNode("Animat");
    a.posEv = (EventInSFVec3f)a.ani.getEventIn("set_translation");
    a.rotEv = (EventInSFRotation)a.ani.getEventIn("set_rotation");
    a.ani2 = browser.getNode("Orient");
    a.rotEv2 = (EventInSFRotation)a.ani2.getEventIn("set_rotation");
    a.trails = browser.getNode("Trails");
    a.addTrailCh = (EventInMFNode) a.trails.getEventIn("addChildren"); 
    a.rmTrailCh = (EventInMFNode) a.trails.getEventIn("removeChildren");
    a.materialC = browser.getNode("CCOLOR");
    a.diffuseColorC = (EventInSFColor) a.materialC.getEventIn("set_color");
    a.materialS = browser.getNode("SCOLOR");
    a.diffuseColorS = (EventInSFColor) a.materialS.getEventIn("set_color");
    a.materialT = browser.getNode("TCOLOR");
    a.diffuseColorT = (EventInSFColor) a.materialT.getEventIn("set_color");
    
    touch = browser.getNode("TS");
    touchTime = (EventOutSFTime) touch.getEventOut("touchTime");
    touchTime.advise(this, new Integer(1));
    
  }
  
  static void addfood(float x, float z, float s) {
    foodstr = " Transform{\n" +
    "translation "+String.valueOf(x)+" "+String.valueOf(Math.pow(((3*s)/(4*Math.PI)),(1.0/3.0))-1)+
    " "+String.valueOf(z)+"\n" +
    "    children [\n" +
    "        Shape{\n" +
    "          appearance Appearance{\n" +
    "              material Material{\n" +
    "                  diffuseColor 0.1 0.7 0.2\n" +
      "              }\n" +
      "           }\n" +
      "           geometry Sphere {radius "+String.valueOf(Math.pow(((3*s)/(4*Math.PI)),(1.0/3.0)))+"}\n" +
    "        }\n" +
    "     ]\n" +
    "}\n";
    food = browser.createVrmlFromString(foodstr);
    foodvec.addElement(food);
    addFoodCh.setValue((Node[])food);
  }
  static void rmfood(int pos) {
    rmFoodCh.setValue((Node[])foodvec.elementAt(pos));
    foodvec.removeElementAt(pos);
    env.foodvp.removeElementAt(pos);
  }
  static void addwater(float x, float z, float s) {
    waterstr = " Transform{\n" +
    "translation "+String.valueOf(x)+" -0.975 "+String.valueOf(z)+"\n" +
    "    children [\n" +
    "        Shape{\n" +
    "          appearance Appearance{\n" +
    "              material Material{\n" +
    "                  diffuseColor 0.1 0.4 0.85\n" +
      "              }\n" +
      "           }\n" +
      "           geometry Cylinder {radius "+String.valueOf(Math.pow((s/Math.PI),(1.0/2.0)))+"\n" +
    "                                            height 0.05}\n"+
    "        }\n" +
    "     ]\n" +
    "}\n";
    water = browser.createVrmlFromString(waterstr);
    watervec.addElement(water);
    addWaterCh.setValue((Node[])water);
  }
  static void rmwater(int pos) {
    rmWaterCh.setValue((Node[])watervec.elementAt(pos));
    watervec.removeElementAt(pos);	
    env.watervp.removeElementAt(pos);	
  }
  void addgrass(float x, float z, float s) {
    grassstr = " Transform{\n" +
    "rotation 1 0 0 3.14"+
    "translation "+String.valueOf(x)+" -0.9 "+String.valueOf(z)+"\n" +
    "    children [\n" +
    "        Shape{\n" +
    "          appearance Appearance{\n" +
    "              material Material{\n" +
    "                  diffuseColor 0.1 0.95 0.5\n" +
      "              }\n" +
      "              texture ImageTexture {\n"+
    "                  url \"moss.jpg\"}\n"+
    "          }\n" +
    "          geometry Cylinder {radius "+String.valueOf(Math.pow((s/Math.PI),(1.0/2.0)))+"\n" +
    "                             height 0.2}\n"+
    "        }\n" +
    "     ]\n" +
    "}\n";
    grass = browser.createVrmlFromString(grassstr);
    grassvec.addElement(grass);
    addGrassCh.setValue((Node[])grass);
  }
  void rmgrass(int pos) {
    rmGrassCh.setValue((Node[])grassvec.elementAt(pos));
    grassvec.removeElementAt(pos);	
    env.grassvp.removeElementAt(pos);	
  }
  void addwall(float x, float z, float sx, float sz) {
    wallstr = " Transform{\n" +
    "translation "+String.valueOf(x)+" 0 "+String.valueOf(z)+"\n" +
    "    children [\n" +
    "        Shape{\n" +
    "          appearance Appearance{\n" +
    "              material Material{\n" +
    "                  diffuseColor 0.5 0.3 0\n" +
      "              }\n" +
      "           }\n" +
      "           geometry Box {size "+String.valueOf(sx)+" 2 "+String.valueOf(sz)+"}\n" +
    "        }\n" +
    "     ]\n" +
    "}\n";
    wall = browser.createVrmlFromString(wallstr);
    wallvec.addElement(wall);
    addWallCh.setValue((Node[])wall);
  }
  void rmwall(int pos) {
    //output.appendText("wallvec sz: "+String.valueOf(wallvec.size())+" wallvp sz: "+String.valueOf(env.wallvp.size())+" pos: "+String.valueOf(pos)+"\n");
    rmWallCh.setValue((Node[])wallvec.elementAt(pos));
    wallvec.removeElementAt(pos); 
    env.wallvp.removeElementAt(pos+4); 
  }
  void addblob(float x, float z, float s) {
    blobstr = " Transform{\n" +
    "scale 1 0.6 0.6"+
    "rotation 0 1 0 "+String.valueOf(rnd.nextFloat()*Math.PI)+"\n"+
    "translation "+String.valueOf(x)+" "+String.valueOf(Math.pow(((3*s)/(4*Math.PI)),(1.0/3.0))-1)+
    " "+String.valueOf(z)+"\n" +
    "    children [\n" +
    "        Shape{\n" +
    "          appearance Appearance{\n" +
    "              material Material{\n" +
    "                  diffuseColor 0.1 0.1 0.2\n" +
      "              }\n" +
      "           }\n" +
      "           geometry Sphere {radius "+String.valueOf(Math.pow(((3*s)/(4*Math.PI)),(1.0/3.0)))+"}\n" +
    "        }\n" +
    "     ]\n" +
    "}\n";
    blob = browser.createVrmlFromString(blobstr);
    blobvec.addElement(blob);
    addBlobCh.setValue((Node[])blob);
  }
  void rmblob(int pos) {
    rmBlobCh.setValue((Node[])blobvec.elementAt(pos));
    blobvec.removeElementAt(pos);
    env.blobvp.removeElementAt(pos);
  }
  void addrspot(float x, float z, float s) {
    rspotstr = " Transform{\n" +
    "translation "+String.valueOf(x)+" -0.995 "+String.valueOf(z)+"\n" +
    "    children [\n" +
    "        Shape{\n" +
    "          appearance Appearance{\n" +
    "              material Material{\n" +
    "                  diffuseColor 0.9 0.0 0.1\n" +
      "              }\n" +
      "           }\n" +
      "           geometry Cylinder {radius "+String.valueOf(Math.pow((s/Math.PI),(1.0/2.0)))+"\n" +
    "                                            height 0.01}\n"+
    "        }\n" +
    "     ]\n" +
    "}\n";
    rspot = browser.createVrmlFromString(rspotstr);
    rspotvec.addElement(rspot);
    addRSpotCh.setValue((Node[])rspot);
  }
  void rmrspot(int pos) {
    rmRSpotCh.setValue((Node[])rspotvec.elementAt(pos));
    rspotvec.removeElementAt(pos);	
    env.rspotvp.removeElementAt(pos);	
  }
  void addyspot(float x, float z, float s) {
    yspotstr = " Transform{\n" +
    "translation "+String.valueOf(x)+" -0.995 "+String.valueOf(z)+"\n" +
    "    children [\n" +
    "        Shape{\n" +
    "          appearance Appearance{\n" +
    "              material Material{\n" +
    "                  diffuseColor 0.9 0.85 0.05\n" +
      "              }\n" +
      "           }\n" +
      "           geometry Cylinder {radius "+String.valueOf(Math.pow((s/Math.PI),(1.0/2.0)))+"\n" +
    "                                            height 0.01}\n"+
    "        }\n" +
    "     ]\n" +
    "}\n";
    yspot = browser.createVrmlFromString(yspotstr);
    yspotvec.addElement(yspot);
    addYSpotCh.setValue((Node[])yspot);
  }
  void rmyspot(int pos) {
    rmYSpotCh.setValue((Node[])yspotvec.elementAt(pos));
    yspotvec.removeElementAt(pos);	
    env.yspotvp.removeElementAt(pos);	
  }
  
  void rmESfood() {
    int pos = (int)Math.floor(rnd.nextFloat()*foodvec.size());
    if (foodvec.size() > 0) {
      output.appendText("Removing food...\n");
      rmfood(pos);
    }
    else {
      output.appendText("No more food to remove, you silly bin!\n");
    }
  }
  void rmESwater() {
    int pos = (int)Math.floor(rnd.nextFloat()*watervec.size());
    if (watervec.size() > 0) {
      output.appendText("Removing water...\n");
      rmwater(pos);
    }
    else {
      output.appendText("No more water to remove, you tit!\n");
    }
  }
  void rmESgrass() {
    int pos = (int)Math.floor(rnd.nextFloat()*grassvec.size());
    if (grassvec.size() > 0) {
      output.appendText("Removing grass...\n");
      rmgrass(pos);
    }
    else {
      output.appendText("No more grass to remove, you smoked it all!!!\n");
    }
  }
  void rmESwall() {
    int pos = (int)Math.floor(rnd.nextFloat()*(wallvec.size()));
    if (wallvec.size() > 0) { //side walls arent in wallvec, only in wallvp
      output.appendText("Removing wall...\n");
      rmwall(pos);
    }
    else {
      output.appendText("No more wall to remove, you creeping twit!\n");
    }
  }
  void rmESblob() {
    int pos = (int)Math.floor(rnd.nextFloat()*blobvec.size());
    if (blobvec.size() > 0) {
      output.appendText("Removing blob...\n");
      rmblob(pos);
    }
    else {
      output.appendText("No more blobs to remove, distracted individual!\n");
    }
  }
  void rmESrspot() {
    int pos = (int)Math.floor(rnd.nextFloat()*rspotvec.size());
    if (rspotvec.size() > 0) {
      output.appendText("Removing red spot...\n");
      rmrspot(pos);
    }
    else {
      output.appendText("No more red spots to remove, confused mind!\n");
    }
  }
  void rmESyspot() {
    int pos = (int)Math.floor(rnd.nextFloat()*yspotvec.size());
    if (yspotvec.size() > 0) {
      output.appendText("Removing yellow spot...\n");
      rmyspot(pos);
    }
    else {
      output.appendText("No more yellow spots to remove, stubborn human!\n");
    }
  }
  
  public void savesim() {
    try {
      PrivilegeManager.enablePrivilege("UniversalFileWrite");
      FileOutputStream ostream = null ;
      try {
        try {
          ostream = new FileOutputStream(saveFile);
        } catch(SecurityException e) {
          output.appendText(e.getMessage());
        }
        ObjectOutputStream p = new ObjectOutputStream(ostream);
        p.writeObject(env);
        p.flush();
        ostream.close();
        output.appendText("Simulation saved.\n");
      } catch(IOException ioe) {
        output.appendText(ioe.getMessage());
      }
    } catch (netscape.security.ForbiddenTargetException e) {
      output.appendText("Security Exception: \n" + 
      "Permission to write files forbidden by user. \n" +
      "Simulation couldn't be saved.\n");
      e.printStackTrace(System.err);
    }
  } 
  public void loadsim() {
    try {
      PrivilegeManager.enablePrivilege("UniversalFileRead");
      FileInputStream istream = null ;
      try {
        try {
          istream = new FileInputStream(saveFile);
        } catch(SecurityException e) {
          output.appendText(e.getMessage());
        }
        ObjectInputStream p = new ObjectInputStream(istream);
        rmES();//clear environment
        try {
          env = (Environment)p.readObject();
        } catch (java.lang.ClassNotFoundException e) {
          output.appendText(e.getMessage());
        }
        istream.close();
        restoreEnv();
        output.appendText("Simulation loaded.\n");
      } catch(IOException ioe) {
        output.appendText(ioe.getMessage());
      }
    } catch (netscape.security.ForbiddenTargetException e) {
      output.appendText("Security Exception: \n" + 
      "Permission to read files forbidden by user. \n" +
      "Simulation couldn't be loaded.\n");
      e.printStackTrace(System.err);
    }
  }
  public void savean() {
    try {
      PrivilegeManager.enablePrivilege("UniversalFileWrite");
      FileOutputStream ostream = null ;
      try {
        try {
          ostream = new FileOutputStream(saveFileAn);
        } catch(SecurityException e) {
          output.appendText(e.getMessage());
        }
        ObjectOutputStream p = new ObjectOutputStream(ostream);
        p.writeObject(a.id);
        p.writeObject(a.a);
        p.writeFloat(a.rp);
        p.writeFloat(a.strength);
        p.writeFloat(a.lucidity);
        p.writeFloat(a.safety);
        p.writeFloat(a.hunger);
        p.writeFloat(a.thirst);
        p.writeFloat(a.fatigue);
        p.writeLong(a.syncstep);
        p.writeObject(a.pos);
        p.writeObject(a.rot);
        p.writeBoolean(a.trailf);
        p.writeBoolean(a.verbose);
        p.writeBoolean(a.immortality);
        p.writeBoolean(a.showblack);
        p.writeBoolean(a.showcoup);
        p.writeBoolean(a.died);
        p.writeObject(a.color);
        p.writeObject(a.color2);
        p.writeObject(a.pos2);
        p.writeObject(a.rot2);
        p.writeObject(a.rot3);
        p.writeDouble(a.aleph);
        p.writeDouble(a.a.alfa);
        p.writeDouble(a.a.beta);
        p.writeDouble(a.a.gamma);
        p.writeDouble(a.a.phi);
        p.writeDouble(a.a.kappa);
        p.writeDouble(a.a.lambda);
        p.writeDouble(a.a.mu);
        p.flush();
        ostream.close();
        output.appendText("Animat "+a.id+" saved.\n");
      } catch(IOException ioe) {
        output.appendText(ioe.getMessage());
      }
    } catch (netscape.security.ForbiddenTargetException e) {
      output.appendText("Security Exception: \n" + 
      "Permission to write files forbidden by user. \n" +
      "Animat couldn't be saved.\n");
      e.printStackTrace(System.err);
    }
  } 
  public void loadan() {
    try {
      PrivilegeManager.enablePrivilege("UniversalFileRead");
      FileInputStream istream = null ;
      try {
        try {
          istream = new FileInputStream(saveFileAn);
        } catch(SecurityException e) {
          output.appendText(e.getMessage());
        }
        ObjectInputStream p = new ObjectInputStream(istream);
        if ( ! pause) {
          sim = null;
          output.appendText("Pausing simulation while loading animat...\n");
        }
        a.destroy();
        try {
          String tmp = (String)p.readObject();
          a = new Animat (tmp,t);
          a.a = (ArqColsCond)p.readObject();
          a.rp = (float)p.readFloat();
          a.strength = (float)p.readFloat();
          a.lucidity = (float)p.readFloat();
          a.safety = (float)p.readFloat();
          a.hunger = (float)p.readFloat();
          a.thirst = (float)p.readFloat();
          a.fatigue = (float)p.readFloat();
          a.syncstep = (long)p.readLong();
          a.pos = (float[])p.readObject();
          a.rot = (float[])p.readObject();
          a.trailf = (boolean)p.readBoolean();
          a.verbose = (boolean)p.readBoolean();
          a.immortality = (boolean)p.readBoolean();
          a.showblack = (boolean)p.readBoolean();
          a.showcoup = (boolean)p.readBoolean();
          a.died = (boolean)p.readBoolean();
          a.color = (float[])p.readObject();
          a.color2 = (float[])p.readObject();
          a.pos2 = (float[])p.readObject();
          a.rot2 = (float[])p.readObject();
          a.rot3 = (float[])p.readObject();
          a.aleph = (double)p.readDouble();
          a.a.alfa = (double)p.readDouble();
          a.a.beta = (double)p.readDouble();
          a.a.gamma = (double)p.readDouble();
          a.a.phi = (double)p.readDouble();
          a.a.kappa = (double)p.readDouble();
          a.a.lambda = (double)p.readDouble();
          a.a.mu = (double)p.readDouble();
        } catch (java.lang.ClassNotFoundException e) {
          output.appendText(e.getMessage());
        }
        istream.close();
        initanimat();
        a.update(false);
        a.greekf.setText(String.valueOf(a.a.alfa));
        output.appendText("Animat "+a.id+" loaded in t= "+String.valueOf(t)+".\n");
        if ( ! pause) {
          sim = new Thread(this, "Simulation");
          sim.start();
          output.appendText("Simulation restored...\n");
        }
      } catch(IOException ioe) {
        output.appendText(ioe.getMessage());
      }
    } catch (netscape.security.ForbiddenTargetException e) {
      output.appendText("Security Exception: \n" + 
      "Permission to read files forbidden by user. \n" +
      "Animat couldn't be loaded.\n");
      e.printStackTrace(System.err);
    }
  }
  void rmES() {
    int i;
    for(i = env.foodvp.size();i > 0;i--)
    rmfood(i-1);
    for(i = env.watervp.size();i > 0;i--)
    rmwater(i-1);
    for(i = env.grassvp.size();i > 0;i--)
    rmgrass(i-1);
    for(i = wallvec.size();i > 0;i--)
    rmwall(i-1);
    for(i = env.blobvp.size();i > 0;i--)
    rmblob(i-1);
    for(i = env.rspotvp.size();i > 0;i--)
    rmrspot(i-1);
    for(i = env.yspotvp.size();i > 0;i--)
    rmyspot(i-1);
  }
  void restoreEnv() {
    int i;
    ExtStim es;
    for (i = 0;i < env.foodvp.size();i++) {
      es = (ExtStim)env.foodvp.elementAt(i);
      addfood(es.x,es.z,es.s);
    }
    for (i = 0;i < env.watervp.size();i++) {
      es = (ExtStim)env.watervp.elementAt(i);
      addwater(es.x,es.z,es.s);
    }
    for (i = 4;i < env.wallvp.size();i++) {
      es = (ExtStim)env.wallvp.elementAt(i);
      addwall(es.x,es.z,es.s,es.s2);
    }
    for (i = 0;i < env.blobvp.size();i++) {
      es = (ExtStim)env.blobvp.elementAt(i);
      addblob(es.x,es.z,es.s);
    }
    for (i = 0;i < env.rspotvp.size();i++) {
      es = (ExtStim)env.rspotvp.elementAt(i);
      addrspot(es.x,es.z,es.s);
    }
    for (i = 0;i < env.yspotvp.size();i++) {
      es = (ExtStim)env.yspotvp.elementAt(i);
      addyspot(es.x,es.z,es.s);
    }
    for (i = 0;i < env.grassvp.size();i++) {
      es = (ExtStim)env.grassvp.elementAt(i);
      addgrass(es.x,es.z,es.s);
    }
    
  }
  
  public boolean action(Event evt, Object whichAction) {
    ExtStim es;
    float x = 0,z = 0,s = 2,s2 = 2;
    boolean ok = true; 
    int opt =-1;
    if (evt.target instanceof MenuItem) {
      if ((String)whichAction == "Save Simulation") {
        if(saveFile == null) { 
          FileDialog fd = new FileDialog(this,"Save Simulation",FileDialog.SAVE);
          fd.setVisible(true);
          saveFile = new String(fd.getFile());
          if(saveFile != null) { 
            output.appendText("Saving simulation in file "+saveFile+"...\n");
            savesim();
          }
        } else {
          output.appendText("Saving simulation in file "+saveFile+"...\n");
          savesim();
        }
        } else
        if ((String)whichAction == "Save Simulation As...") {
        FileDialog fd = new FileDialog(this,"Save Simulation",FileDialog.SAVE);
        fd.setVisible(true);
        saveFile = new String(fd.getFile());
        if(saveFile != null) { 
          output.appendText("Saving simulation in file "+saveFile+"...\n");
          savesim();
        }
        } else
        if ((String)whichAction == "Load Simulation") {
        FileDialog fd = new FileDialog(this,"Load Simulation",FileDialog.LOAD);
        fd.setVisible(true);
        saveFile = new String(fd.getFile());
        if(saveFile != null) { 
          output.appendText("Loading simulation from file "+saveFile+"...\n");
          loadsim();
        }
        
        } else
        if ((String)whichAction == "Reset Simulation") {
        SimBase.reset();
        } else
        if ((String)whichAction == "New Animat") {
        
        } else
        if ((String)whichAction == "Save Animat") {
        if(saveFileAn == null) { 
          FileDialog fd = new FileDialog(this,"Save Animat",FileDialog.SAVE);
          fd.setVisible(true);
          saveFileAn = new String(fd.getFile());
          if(saveFileAn != null) { 
            output.appendText("Saving animat in file "+saveFileAn+"...\n");
            savean();
          } 
        } else {
          output.appendText("Saving animat in file "+saveFileAn+"...\n");
          savean();
        }
        
        } else
        if ((String)whichAction == "Save Animat As...") {
        FileDialog fd = new FileDialog(this,"Save Animat",FileDialog.SAVE);
        fd.setVisible(true);
        saveFileAn = new String(fd.getFile());
        if(saveFileAn != null) { 
          output.appendText("Saving animat in file "+saveFileAn+"...\n");
          savean();
        } 
        } else
        if ((String)whichAction == "Load Animat") {
        FileDialog fd = new FileDialog(this,"Load animat",FileDialog.LOAD);
        fd.setVisible(true);
        saveFileAn = new String(fd.getFile());
        if(saveFileAn != null) { 
          output.appendText("Loading animat from file "+saveFileAn+"...\n");
          loadan();
        }
        
        } else
        if ((String)whichAction == "Remove Animat") {
        
        } else
        if ((String)whichAction == "Remove All Animats") {
        
      }
      } else
      if (evt.target instanceof Button) {
      Button b = (Button) evt.target;
      if (b.getLabel() == "Add ES") {
        if (esrnd.getState()) {
          x = (rnd.nextFloat()*SZ)-(SZ/2);
          z = (rnd.nextFloat()*SZ)-(SZ/2);
          s = (rnd.nextFloat()*(float)4.9)+(float)0.1;
          s2 = (rnd.nextFloat()*(float)4.9)+(float)0.1;
        }
        else {
          try {
            x = Float.valueOf(esxf.getText()).floatValue();
            z = Float.valueOf(eszf.getText()).floatValue();
            s = Float.valueOf(essf.getText()).floatValue();
            s2 = Float.valueOf(essf2.getText()).floatValue();
          }
          catch (NumberFormatException e) {
            output.appendText("Please fill the fileds correctly!\n");
            ok = false;
          }
        }
        if (ok) {
          opt = extStimCh.getSelectedIndex();
          switch(opt) {
            case (0):
            output.appendText("Adding food at x="+String.valueOf(x)+" z="+String.valueOf(z)+"; size="+String.valueOf(s)+"...\n");
            es = new ExtStim(x,z,s,0,(int)1);
            env.foodvp.addElement(es);
            addfood(x,z,s); 
            break;
            case (1):
            output.appendText("Adding water at x="+String.valueOf(x)+" z="+String.valueOf(z)+"; size="+String.valueOf(s)+"...\n");
            es = new ExtStim(x,z,s,0,(int)2);
            env.watervp.addElement(es);
            addwater(x,z,s);
            break;
            case (2):
            output.appendText("Adding grass at x="+String.valueOf(x)+" z="+String.valueOf(z)+"; size="+String.valueOf(s)+"...\n");
            es = new ExtStim(x,z,s,0,(int)11);
            env.grassvp.addElement(es);
            addgrass(x,z,s);
            break;
            case (3):
            output.appendText("Adding wall at x="+String.valueOf(x)+" z="+String.valueOf(z)+"; size="+String.valueOf(s)+" x "+String.valueOf(s2)+"...\n");
            es = new ExtStim(x,z,s,s2,(int)3);
            env.wallvp.addElement(es);
            addwall(x,z,s,s2);
            break;
            case (4):
            output.appendText("Adding blob at x="+String.valueOf(x)+" z="+String.valueOf(z)+"; size="+String.valueOf(s)+"...\n");
            es = new ExtStim(x,z,s,0,(int)8);
            env.blobvp.addElement(es);
            addblob(x,z,s);
            break;
            case (5):
            output.appendText("Adding red spot at x="+String.valueOf(x)+" z="+String.valueOf(z)+"; size="+String.valueOf(s)+"...\n");
            es = new ExtStim(x,z,s,0,(int)9);
            env.rspotvp.addElement(es);
            addrspot(x,z,s);
            break;
            case (6):
            output.appendText("Adding yellow spot at x="+String.valueOf(x)+" z="+String.valueOf(z)+"; size="+String.valueOf(s)+"...\n");
            es = new ExtStim(x,z,s,0,(int)10);
            env.yspotvp.addElement(es);
            addyspot(x,z,s);
            break;
            default:
            output.appendText("Error. Please select a valid external stimulus\n");
            break;
          }
        }
      }
      else if (b.getLabel() == "Rmv ES") {
        opt = extStimCh.getSelectedIndex();
        switch(opt) {
          case (0):rmESfood();break;
          case (1):rmESwater();break;
          case (2):rmESgrass();break;
          case (3):rmESwall();break;
          case (4):rmESblob();break;
          case (5):rmESrspot();break;
          case (6):rmESyspot();break;
          default:
          output.appendText("Error. Please select a valid external stimulus\n");
          break;
        }
      }
      else if (b.getLabel() == "Pause") {
        if (pause) {
          sim = new Thread(this, "Simulation"); 
          sim.start();
          output.appendText("Simulation Restored.\n");
        }
        else {
          output.appendText("Simulation Paused.\n");
          sim = null;
        }
        pause =! pause;
      }
      else if (b.getLabel() == "Start ") {
        start.setLabel("Pause");
        sim = new Thread(this, "Simulation");
        sim.start();
        pause = false;
        output.appendText("Simulation Started.\n");
      }
      else if (b.getLabel() == "Verbose") {
        if(verbose)
          output.appendText("OK, I'll be quiet.\n");
        else
          output.appendText("To inform and serve, sir!\n");
        verbose =! verbose;
      }
      else if (b.getLabel() == "Set Dly") {
        long dlyprov =-1;
        try {
          dlyprov = Long.valueOf(dly.getText()).longValue();
        }
        catch (NumberFormatException e) {
          output.appendText("Please fill the fileds correctly!\n");
          ok = false;
        }
        if (ok) {
          if (dlyprov < 0) {
            output.appendText("Delay can't be negative!\n");
          } else {
            delay = dlyprov;
            output.appendText("New delay rate: "+String.valueOf(delay)+" milliseconds per sim cycle\n");
          }
        }
      }
      else if (b.getLabel() == "Clear Output") {
        output.setText("\nNice and clean...\n");
      }
      
      } else
      if (evt.target instanceof CheckboxMenuItem) {
      if ((String)whichAction == "Save Animats with Sim") { 
      }
    }
    return true;
  }
  
  public void callback(EventOut who, double when, Object which) {
    Integer whichNum = (Integer) which;
    if (whichNum.intValue() == 1) {
      selectedanimat = 0;
      output.appendText("Animat "+a.id+" selected\n");
      a.output.appendText("Animat selected.\n");
    }
    if (whichNum.intValue() == 2) {
      output.appendText("bla bla...\n");
    }
  }
  
  
  public void run() {
    Thread myThread = Thread.currentThread();
    while (sim == myThread) { //Simulation
      t++;
      try {
        sim.sleep(delay);
      } catch (InterruptedException insomnia) { }
      a.go();
      if (verbose) {
        output.appendText("t: "+String.valueOf(t)+"\n");
      }
    }
  }
  
  public void stop() {
    if ( ! pause) {
      sim = null;//stop sim thread
    }
  }
  
  public void destroy() {
    int i;
    stop();
    output.appendText("Closing Simulation... (this might take a little while...)");
    for(i = env.foodvp.size();i > 0;i--)
    rmfood(i-1);
    for(i = env.watervp.size();i > 0;i--)
    rmwater(i-1);
    for(i = env.grassvp.size();i > 0;i--)
    rmgrass(i-1);
    for(i = wallvec.size();i > 0;i--)
    rmwall(i-1);
    for(i = env.blobvp.size();i > 0;i--)
    rmblob(i-1);
    for(i = env.rspotvp.size();i > 0;i--)
    rmrspot(i-1);
    for(i = env.yspotvp.size();i > 0;i--)
    rmyspot(i-1);
    //rmES();
    a.destroy();
    this.hide();
    dispose();
  }
  
}